/* confirm.c generated by valac 0.56.18, the Vala compiler
 * generated from confirm.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2025 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <adwaita.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_CONFIRM_DIALOG (haguichi_confirm_dialog_get_type ())
#define HAGUICHI_CONFIRM_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_CONFIRM_DIALOG, HaguichiConfirmDialog))
#define HAGUICHI_CONFIRM_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_CONFIRM_DIALOG, HaguichiConfirmDialogClass))
#define HAGUICHI_IS_CONFIRM_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_CONFIRM_DIALOG))
#define HAGUICHI_IS_CONFIRM_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_CONFIRM_DIALOG))
#define HAGUICHI_CONFIRM_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_CONFIRM_DIALOG, HaguichiConfirmDialogClass))

typedef struct _HaguichiConfirmDialog HaguichiConfirmDialog;
typedef struct _HaguichiConfirmDialogClass HaguichiConfirmDialogClass;
typedef struct _HaguichiConfirmDialogPrivate HaguichiConfirmDialogPrivate;
enum  {
	HAGUICHI_CONFIRM_DIALOG_0_PROPERTY,
	HAGUICHI_CONFIRM_DIALOG_NUM_PROPERTIES
};
static GParamSpec* haguichi_confirm_dialog_properties[HAGUICHI_CONFIRM_DIALOG_NUM_PROPERTIES];

#define HAGUICHI_TYPE_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))
#define HAGUICHI_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	HAGUICHI_CONFIRM_DIALOG_CONFIRM_SIGNAL,
	HAGUICHI_CONFIRM_DIALOG_NUM_SIGNALS
};
static guint haguichi_confirm_dialog_signals[HAGUICHI_CONFIRM_DIALOG_NUM_SIGNALS] = {0};

struct _HaguichiConfirmDialog {
	GObject parent_instance;
	HaguichiConfirmDialogPrivate * priv;
};

struct _HaguichiConfirmDialogClass {
	GObjectClass parent_class;
};

static gpointer haguichi_confirm_dialog_parent_class = NULL;
VALA_EXTERN HaguichiWindow* haguichi_win;

VALA_EXTERN GType haguichi_confirm_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiConfirmDialog, g_object_unref)
VALA_EXTERN HaguichiConfirmDialog* haguichi_confirm_dialog_new (GtkWidget* parent,
                                                    const gchar* heading,
                                                    const gchar* body,
                                                    const gchar* confirm_label,
                                                    AdwResponseAppearance response_appearance);
VALA_EXTERN HaguichiConfirmDialog* haguichi_confirm_dialog_construct (GType object_type,
                                                          GtkWidget* parent,
                                                          const gchar* heading,
                                                          const gchar* body,
                                                          const gchar* confirm_label,
                                                          AdwResponseAppearance response_appearance);
static void __lambda4_ (HaguichiConfirmDialog* self,
                 AdwAlertDialog* dialog,
                 const gchar* response);
static void ___lambda4__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                            const gchar* response,
                                            gpointer self);
VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
VALA_EXTERN void haguichi_window_show_dialog (HaguichiWindow* self,
                                  GtkWidget* widget);
static GType haguichi_confirm_dialog_get_type_once (void);

static void
__lambda4_ (HaguichiConfirmDialog* self,
            AdwAlertDialog* dialog,
            const gchar* response)
{
#line 33 "../src/dialogs/confirm.vala"
	g_return_if_fail (dialog != NULL);
#line 33 "../src/dialogs/confirm.vala"
	g_return_if_fail (response != NULL);
#line 34 "../src/dialogs/confirm.vala"
	if (g_strcmp0 (response, "confirm") == 0) {
#line 35 "../src/dialogs/confirm.vala"
		g_signal_emit (self, haguichi_confirm_dialog_signals[HAGUICHI_CONFIRM_DIALOG_CONFIRM_SIGNAL], 0);
#line 125 "confirm.c"
	}
}

static void
___lambda4__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                       const gchar* response,
                                       gpointer self)
{
#line 33 "../src/dialogs/confirm.vala"
	__lambda4_ ((HaguichiConfirmDialog*) self, _sender, response);
#line 136 "confirm.c"
}

HaguichiConfirmDialog*
haguichi_confirm_dialog_construct (GType object_type,
                                   GtkWidget* parent,
                                   const gchar* heading,
                                   const gchar* body,
                                   const gchar* confirm_label,
                                   AdwResponseAppearance response_appearance)
{
	HaguichiConfirmDialog * self = NULL;
	AdwAlertDialog* dialog = NULL;
	AdwAlertDialog* _tmp0_;
	AdwAlertDialog* _tmp1_;
	AdwAlertDialog* _tmp2_;
	AdwAlertDialog* _tmp3_;
	AdwAlertDialog* _tmp4_;
	AdwAlertDialog* _tmp5_;
	AdwAlertDialog* _tmp6_;
	HaguichiWindow* _tmp7_;
#line 17 "../src/dialogs/confirm.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 17 "../src/dialogs/confirm.vala"
	g_return_val_if_fail (heading != NULL, NULL);
#line 17 "../src/dialogs/confirm.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 17 "../src/dialogs/confirm.vala"
	g_return_val_if_fail (confirm_label != NULL, NULL);
#line 17 "../src/dialogs/confirm.vala"
	self = (HaguichiConfirmDialog*) g_object_new (object_type, NULL);
#line 23 "../src/dialogs/confirm.vala"
	_tmp0_ = (AdwAlertDialog*) adw_alert_dialog_new (heading, body);
#line 23 "../src/dialogs/confirm.vala"
	g_object_ref_sink (_tmp0_);
#line 23 "../src/dialogs/confirm.vala"
	dialog = _tmp0_;
#line 25 "../src/dialogs/confirm.vala"
	_tmp1_ = dialog;
#line 25 "../src/dialogs/confirm.vala"
	adw_alert_dialog_add_response (_tmp1_, "cancel", _ ("_Cancel"));
#line 26 "../src/dialogs/confirm.vala"
	_tmp2_ = dialog;
#line 26 "../src/dialogs/confirm.vala"
	adw_alert_dialog_add_response (_tmp2_, "confirm", confirm_label);
#line 28 "../src/dialogs/confirm.vala"
	_tmp3_ = dialog;
#line 28 "../src/dialogs/confirm.vala"
	adw_alert_dialog_set_response_appearance (_tmp3_, "confirm", response_appearance);
#line 30 "../src/dialogs/confirm.vala"
	_tmp4_ = dialog;
#line 30 "../src/dialogs/confirm.vala"
	adw_alert_dialog_set_default_response (_tmp4_, "confirm");
#line 31 "../src/dialogs/confirm.vala"
	_tmp5_ = dialog;
#line 31 "../src/dialogs/confirm.vala"
	adw_alert_dialog_set_close_response (_tmp5_, "cancel");
#line 33 "../src/dialogs/confirm.vala"
	_tmp6_ = dialog;
#line 33 "../src/dialogs/confirm.vala"
	g_signal_connect_object (_tmp6_, "response", (GCallback) ___lambda4__adw_alert_dialog_response, self, 0);
#line 39 "../src/dialogs/confirm.vala"
	_tmp7_ = haguichi_win;
#line 39 "../src/dialogs/confirm.vala"
	if (parent == G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget)) {
#line 201 "confirm.c"
		HaguichiWindow* _tmp8_;
		AdwAlertDialog* _tmp9_;
#line 40 "../src/dialogs/confirm.vala"
		_tmp8_ = haguichi_win;
#line 40 "../src/dialogs/confirm.vala"
		_tmp9_ = dialog;
#line 40 "../src/dialogs/confirm.vala"
		haguichi_window_show_dialog (_tmp8_, (GtkWidget*) _tmp9_);
#line 210 "confirm.c"
	} else {
		AdwAlertDialog* _tmp10_;
#line 42 "../src/dialogs/confirm.vala"
		_tmp10_ = dialog;
#line 42 "../src/dialogs/confirm.vala"
		adw_dialog_present ((AdwDialog*) _tmp10_, parent);
#line 217 "confirm.c"
	}
#line 17 "../src/dialogs/confirm.vala"
	_g_object_unref0 (dialog);
#line 17 "../src/dialogs/confirm.vala"
	return self;
#line 223 "confirm.c"
}

HaguichiConfirmDialog*
haguichi_confirm_dialog_new (GtkWidget* parent,
                             const gchar* heading,
                             const gchar* body,
                             const gchar* confirm_label,
                             AdwResponseAppearance response_appearance)
{
#line 17 "../src/dialogs/confirm.vala"
	return haguichi_confirm_dialog_construct (HAGUICHI_TYPE_CONFIRM_DIALOG, parent, heading, body, confirm_label, response_appearance);
#line 235 "confirm.c"
}

static void
haguichi_confirm_dialog_class_init (HaguichiConfirmDialogClass * klass,
                                    gpointer klass_data)
{
#line 14 "../src/dialogs/confirm.vala"
	haguichi_confirm_dialog_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/dialogs/confirm.vala"
	haguichi_confirm_dialog_signals[HAGUICHI_CONFIRM_DIALOG_CONFIRM_SIGNAL] = g_signal_new ("confirm", HAGUICHI_TYPE_CONFIRM_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 246 "confirm.c"
}

static void
haguichi_confirm_dialog_instance_init (HaguichiConfirmDialog * self,
                                       gpointer klass)
{
}

static GType
haguichi_confirm_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiConfirmDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_confirm_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiConfirmDialog), 0, (GInstanceInitFunc) haguichi_confirm_dialog_instance_init, NULL };
	GType haguichi_confirm_dialog_type_id;
	haguichi_confirm_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "HaguichiConfirmDialog", &g_define_type_info, 0);
	return haguichi_confirm_dialog_type_id;
}

GType
haguichi_confirm_dialog_get_type (void)
{
	static volatile gsize haguichi_confirm_dialog_type_id__once = 0;
	if (g_once_init_enter (&haguichi_confirm_dialog_type_id__once)) {
		GType haguichi_confirm_dialog_type_id;
		haguichi_confirm_dialog_type_id = haguichi_confirm_dialog_get_type_once ();
		g_once_init_leave (&haguichi_confirm_dialog_type_id__once, haguichi_confirm_dialog_type_id);
	}
	return haguichi_confirm_dialog_type_id__once;
}

