/* status.c generated by valac 0.56.18, the Vala compiler
 * generated from status.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_STATUS (status_get_type ())
#define STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS, Status))
#define STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS, StatusClass))
#define IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS))
#define IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS))
#define STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS, StatusClass))

typedef struct _Status Status;
typedef struct _StatusClass StatusClass;
typedef struct _StatusPrivate StatusPrivate;
enum  {
	STATUS_0_PROPERTY,
	STATUS_NUM_PROPERTIES
};
static GParamSpec* status_properties[STATUS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Status {
	GObject parent_instance;
	StatusPrivate * priv;
	gint status_int;
	gchar* status_text;
	gchar* status_sortable;
	gchar* message;
	gchar* connection_type;
};

struct _StatusClass {
	GObjectClass parent_class;
};

static gpointer status_parent_class = NULL;

VALA_EXTERN GType status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Status, g_object_unref)
VALA_EXTERN Status* status_new (const gchar* status);
VALA_EXTERN Status* status_construct (GType object_type,
                          const gchar* status);
VALA_EXTERN void status_set_status (Status* self,
                        const gchar* status);
VALA_EXTERN Status* status_new_complete (const gchar* status,
                             const gchar* connection,
                             const gchar* _message);
VALA_EXTERN Status* status_construct_complete (GType object_type,
                                   const gchar* status,
                                   const gchar* connection,
                                   const gchar* _message);
static void status_set_connection_type (Status* self,
                                 const gchar* connection);
VALA_EXTERN gchar* status_get_css_classes (Status* self);
static void status_finalize (GObject * obj);
static GType status_get_type_once (void);

Status*
status_construct (GType object_type,
                  const gchar* status)
{
	Status * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 20 "../src/status.vala"
	g_return_val_if_fail (status != NULL, NULL);
#line 20 "../src/status.vala"
	self = (Status*) g_object_new (object_type, NULL);
#line 21 "../src/status.vala"
	_tmp0_ = g_strdup ("");
#line 21 "../src/status.vala"
	_g_free0 (self->message);
#line 21 "../src/status.vala"
	self->message = _tmp0_;
#line 22 "../src/status.vala"
	_tmp1_ = g_strdup ("");
#line 22 "../src/status.vala"
	_g_free0 (self->connection_type);
#line 22 "../src/status.vala"
	self->connection_type = _tmp1_;
#line 23 "../src/status.vala"
	status_set_status (self, status);
#line 20 "../src/status.vala"
	return self;
#line 121 "status.c"
}

Status*
status_new (const gchar* status)
{
#line 20 "../src/status.vala"
	return status_construct (TYPE_STATUS, status);
#line 129 "status.c"
}

Status*
status_construct_complete (GType object_type,
                           const gchar* status,
                           const gchar* connection,
                           const gchar* _message)
{
	Status * self = NULL;
	gchar* _tmp0_;
#line 26 "../src/status.vala"
	g_return_val_if_fail (status != NULL, NULL);
#line 26 "../src/status.vala"
	self = (Status*) g_object_new (object_type, NULL);
#line 27 "../src/status.vala"
	_tmp0_ = g_strdup (_message);
#line 27 "../src/status.vala"
	_g_free0 (self->message);
#line 27 "../src/status.vala"
	self->message = _tmp0_;
#line 28 "../src/status.vala"
	status_set_connection_type (self, connection);
#line 29 "../src/status.vala"
	status_set_status (self, status);
#line 26 "../src/status.vala"
	return self;
#line 156 "status.c"
}

Status*
status_new_complete (const gchar* status,
                     const gchar* connection,
                     const gchar* _message)
{
#line 26 "../src/status.vala"
	return status_construct_complete (TYPE_STATUS, status, connection, _message);
#line 166 "status.c"
}

void
status_set_status (Status* self,
                   const gchar* status)
{
#line 32 "../src/status.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/status.vala"
	g_return_if_fail (status != NULL);
#line 33 "../src/status.vala"
	if (g_strcmp0 (status, " ") == 0) {
#line 179 "status.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 34 "../src/status.vala"
		self->status_int = 0;
#line 35 "../src/status.vala"
		_tmp0_ = g_strdup (_ ("Offline"));
#line 35 "../src/status.vala"
		_g_free0 (self->status_text);
#line 35 "../src/status.vala"
		self->status_text = _tmp0_;
#line 36 "../src/status.vala"
		_tmp1_ = g_strdup ("f");
#line 36 "../src/status.vala"
		_g_free0 (self->status_sortable);
#line 36 "../src/status.vala"
		self->status_sortable = _tmp1_;
#line 196 "status.c"
	} else {
#line 37 "../src/status.vala"
		if (g_strcmp0 (status, "*") == 0) {
#line 200 "status.c"
			gchar* _tmp2_;
			const gchar* _tmp3_;
#line 38 "../src/status.vala"
			self->status_int = 1;
#line 39 "../src/status.vala"
			_tmp2_ = g_strdup (_ ("Online"));
#line 39 "../src/status.vala"
			_g_free0 (self->status_text);
#line 39 "../src/status.vala"
			self->status_text = _tmp2_;
#line 41 "../src/status.vala"
			_tmp3_ = self->connection_type;
#line 41 "../src/status.vala"
			if (g_strcmp0 (_tmp3_, _ ("Relayed")) == 0) {
#line 215 "status.c"
				gchar* _tmp4_;
#line 42 "../src/status.vala"
				_tmp4_ = g_strdup ("b");
#line 42 "../src/status.vala"
				_g_free0 (self->status_sortable);
#line 42 "../src/status.vala"
				self->status_sortable = _tmp4_;
#line 223 "status.c"
			} else {
				gchar* _tmp5_;
#line 44 "../src/status.vala"
				_tmp5_ = g_strdup ("a");
#line 44 "../src/status.vala"
				_g_free0 (self->status_sortable);
#line 44 "../src/status.vala"
				self->status_sortable = _tmp5_;
#line 232 "status.c"
			}
		} else {
#line 46 "../src/status.vala"
			if (g_strcmp0 (status, "x") == 0) {
#line 237 "status.c"
				gchar* _tmp6_;
				gchar* _tmp7_;
#line 47 "../src/status.vala"
				self->status_int = 2;
#line 48 "../src/status.vala"
				_tmp6_ = g_strdup (_ ("Unreachable"));
#line 48 "../src/status.vala"
				_g_free0 (self->status_text);
#line 48 "../src/status.vala"
				self->status_text = _tmp6_;
#line 49 "../src/status.vala"
				_tmp7_ = g_strdup ("d");
#line 49 "../src/status.vala"
				_g_free0 (self->status_sortable);
#line 49 "../src/status.vala"
				self->status_sortable = _tmp7_;
#line 254 "status.c"
			} else {
#line 50 "../src/status.vala"
				if (g_strcmp0 (status, "?") == 0) {
#line 258 "status.c"
					gchar* _tmp8_;
					gchar* _tmp9_;
#line 51 "../src/status.vala"
					self->status_int = 3;
#line 52 "../src/status.vala"
					_tmp8_ = g_strdup (_ ("Awaiting approval"));
#line 52 "../src/status.vala"
					_g_free0 (self->status_text);
#line 52 "../src/status.vala"
					self->status_text = _tmp8_;
#line 53 "../src/status.vala"
					_tmp9_ = g_strdup ("c");
#line 53 "../src/status.vala"
					_g_free0 (self->status_sortable);
#line 53 "../src/status.vala"
					self->status_sortable = _tmp9_;
#line 275 "status.c"
				} else {
#line 54 "../src/status.vala"
					if (g_strcmp0 (status, "!") == 0) {
#line 279 "status.c"
						gchar* _tmp10_;
						gchar* _tmp11_;
						const gchar* _tmp12_;
#line 55 "../src/status.vala"
						self->status_int = 4;
#line 56 "../src/status.vala"
						_tmp10_ = g_strdup (_ ("Unknown error"));
#line 56 "../src/status.vala"
						_g_free0 (self->status_text);
#line 56 "../src/status.vala"
						self->status_text = _tmp10_;
#line 57 "../src/status.vala"
						_tmp11_ = g_strdup ("e");
#line 57 "../src/status.vala"
						_g_free0 (self->status_sortable);
#line 57 "../src/status.vala"
						self->status_sortable = _tmp11_;
#line 59 "../src/status.vala"
						_tmp12_ = self->message;
#line 59 "../src/status.vala"
						if (g_strcmp0 (_tmp12_, "IP protocol mismatch between you and peer") == 0) {
#line 301 "status.c"
							gchar* _tmp13_;
#line 60 "../src/status.vala"
							_tmp13_ = g_strdup (_ ("Protocol mismatch"));
#line 60 "../src/status.vala"
							_g_free0 (self->status_text);
#line 60 "../src/status.vala"
							self->status_text = _tmp13_;
#line 309 "status.c"
						} else {
							const gchar* _tmp14_;
#line 61 "../src/status.vala"
							_tmp14_ = self->message;
#line 61 "../src/status.vala"
							if (g_strcmp0 (_tmp14_, "This address is also used by another peer") == 0) {
#line 316 "status.c"
								gchar* _tmp15_;
#line 62 "../src/status.vala"
								_tmp15_ = g_strdup (_ ("Conflicting address"));
#line 62 "../src/status.vala"
								_g_free0 (self->status_text);
#line 62 "../src/status.vala"
								self->status_text = _tmp15_;
#line 324 "status.c"
							}
						}
					}
				}
			}
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 350 "status.c"
}

static void
status_set_connection_type (Status* self,
                            const gchar* connection)
{
	gchar* _tmp0_;
#line 67 "../src/status.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/status.vala"
	_tmp0_ = g_strdup ("");
#line 68 "../src/status.vala"
	_g_free0 (self->connection_type);
#line 68 "../src/status.vala"
	self->connection_type = _tmp0_;
#line 70 "../src/status.vala"
	if (connection == NULL) {
#line 71 "../src/status.vala"
		return;
#line 370 "status.c"
	} else {
#line 72 "../src/status.vala"
		if (g_strcmp0 (connection, "direct") == 0) {
#line 374 "status.c"
			gchar* _tmp1_;
#line 73 "../src/status.vala"
			_tmp1_ = g_strdup (_ ("Direct"));
#line 73 "../src/status.vala"
			_g_free0 (self->connection_type);
#line 73 "../src/status.vala"
			self->connection_type = _tmp1_;
#line 382 "status.c"
		} else {
#line 74 "../src/status.vala"
			if (string_contains (connection, "via ")) {
#line 386 "status.c"
				gchar* _tmp2_;
#line 75 "../src/status.vala"
				_tmp2_ = g_strdup (_ ("Relayed"));
#line 75 "../src/status.vala"
				_g_free0 (self->connection_type);
#line 75 "../src/status.vala"
				self->connection_type = _tmp2_;
#line 394 "status.c"
			}
		}
	}
}

gchar*
status_get_css_classes (Status* self)
{
	gchar* icon_name = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 79 "../src/status.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "../src/status.vala"
	_tmp0_ = g_strdup ("");
#line 80 "../src/status.vala"
	icon_name = _tmp0_;
#line 82 "../src/status.vala"
	if (self->status_int == 0) {
#line 414 "status.c"
		gchar* _tmp1_;
#line 83 "../src/status.vala"
		_tmp1_ = g_strdup ("network-node-offline");
#line 83 "../src/status.vala"
		_g_free0 (icon_name);
#line 83 "../src/status.vala"
		icon_name = _tmp1_;
#line 422 "status.c"
	}
#line 84 "../src/status.vala"
	if (self->status_int == 1) {
#line 426 "status.c"
		const gchar* _tmp2_;
#line 85 "../src/status.vala"
		_tmp2_ = self->connection_type;
#line 85 "../src/status.vala"
		if (g_strcmp0 (_tmp2_, _ ("Relayed")) == 0) {
#line 432 "status.c"
			gchar* _tmp3_;
#line 86 "../src/status.vala"
			_tmp3_ = g_strdup ("network-node-online-relayed");
#line 86 "../src/status.vala"
			_g_free0 (icon_name);
#line 86 "../src/status.vala"
			icon_name = _tmp3_;
#line 440 "status.c"
		} else {
			gchar* _tmp4_;
#line 88 "../src/status.vala"
			_tmp4_ = g_strdup ("network-node-online");
#line 88 "../src/status.vala"
			_g_free0 (icon_name);
#line 88 "../src/status.vala"
			icon_name = _tmp4_;
#line 449 "status.c"
		}
	} else {
#line 90 "../src/status.vala"
		if (self->status_int == 2) {
#line 454 "status.c"
			gchar* _tmp5_;
#line 91 "../src/status.vala"
			_tmp5_ = g_strdup ("network-node-unreachable");
#line 91 "../src/status.vala"
			_g_free0 (icon_name);
#line 91 "../src/status.vala"
			icon_name = _tmp5_;
#line 462 "status.c"
		} else {
#line 92 "../src/status.vala"
			if (self->status_int == 3) {
#line 466 "status.c"
				gchar* _tmp6_;
#line 93 "../src/status.vala"
				_tmp6_ = g_strdup ("network-node-unapproved");
#line 93 "../src/status.vala"
				_g_free0 (icon_name);
#line 93 "../src/status.vala"
				icon_name = _tmp6_;
#line 474 "status.c"
			} else {
#line 94 "../src/status.vala"
				if (self->status_int == 4) {
#line 478 "status.c"
					gchar* _tmp7_;
#line 95 "../src/status.vala"
					_tmp7_ = g_strdup ("network-node-error");
#line 95 "../src/status.vala"
					_g_free0 (icon_name);
#line 95 "../src/status.vala"
					icon_name = _tmp7_;
#line 486 "status.c"
				}
			}
		}
	}
#line 98 "../src/status.vala"
	result = icon_name;
#line 98 "../src/status.vala"
	return result;
#line 495 "status.c"
}

static void
status_class_init (StatusClass * klass,
                   gpointer klass_data)
{
#line 13 "../src/status.vala"
	status_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/status.vala"
	G_OBJECT_CLASS (klass)->finalize = status_finalize;
#line 506 "status.c"
}

static void
status_instance_init (Status * self,
                      gpointer klass)
{
}

static void
status_finalize (GObject * obj)
{
	Status * self;
#line 13 "../src/status.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS, Status);
#line 15 "../src/status.vala"
	_g_free0 (self->status_text);
#line 16 "../src/status.vala"
	_g_free0 (self->status_sortable);
#line 17 "../src/status.vala"
	_g_free0 (self->message);
#line 18 "../src/status.vala"
	_g_free0 (self->connection_type);
#line 13 "../src/status.vala"
	G_OBJECT_CLASS (status_parent_class)->finalize (obj);
#line 531 "status.c"
}

static GType
status_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StatusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Status), 0, (GInstanceInitFunc) status_instance_init, NULL };
	GType status_type_id;
	status_type_id = g_type_register_static (G_TYPE_OBJECT, "Status", &g_define_type_info, 0);
	return status_type_id;
}

GType
status_get_type (void)
{
	static volatile gsize status_type_id__once = 0;
	if (g_once_init_enter (&status_type_id__once)) {
		GType status_type_id;
		status_type_id = status_get_type_once ();
		g_once_init_leave (&status_type_id__once, status_type_id);
	}
	return status_type_id__once;
}

