/* utils.c generated by valac 0.56.18, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2025 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib/gstdio.h>
#include <libportal/portal.h>
#include <adwaita.h>

#define HAGUICHI_HAMACHI_DATA_PATH "/var/lib/logmein-hamachi"
#define HAGUICHI_HAMACHI_CONFIG_PATH HAGUICHI_HAMACHI_DATA_PATH "/h2-engine-override.cfg"
#define CONFIG_VERSION "1.5.2"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_UTILS (haguichi_utils_get_type ())
#define HAGUICHI_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_UTILS, HaguichiUtils))
#define HAGUICHI_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_UTILS, HaguichiUtilsClass))
#define HAGUICHI_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_UTILS))
#define HAGUICHI_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_UTILS))
#define HAGUICHI_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_UTILS, HaguichiUtilsClass))

typedef struct _HaguichiUtils HaguichiUtils;
typedef struct _HaguichiUtilsClass HaguichiUtilsClass;
typedef struct _HaguichiUtilsPrivate HaguichiUtilsPrivate;
enum  {
	HAGUICHI_UTILS_0_PROPERTY,
	HAGUICHI_UTILS_NUM_PROPERTIES
};
static GParamSpec* haguichi_utils_properties[HAGUICHI_UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HaguichiUtils {
	GObject parent_instance;
	HaguichiUtilsPrivate * priv;
};

struct _HaguichiUtilsClass {
	GObjectClass parent_class;
};

static gpointer haguichi_utils_parent_class = NULL;
VALA_EXTERN gchar* haguichi_command_terminal;
VALA_EXTERN gchar* haguichi_command_file_manager;
VALA_EXTERN gchar* haguichi_command_remote_desktop;
VALA_EXTERN gchar* haguichi_hamachi_version;
VALA_EXTERN gchar* haguichi_hamachi_ip_version;
VALA_EXTERN gchar* haguichi_hamachi_service;
VALA_EXTERN gchar* haguichi_command_sudo;

VALA_EXTERN GType haguichi_utils_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiUtils, g_object_unref)
VALA_EXTERN gchar* haguichi_utils_remove_mnemonics (gchar* label);
VALA_EXTERN gchar* haguichi_utils_clean_string (gchar* _string);
VALA_EXTERN gchar* haguichi_utils_parse_nick (const gchar* nick);
VALA_EXTERN GtkIconTheme* haguichi_utils_get_icon_theme (void);
VALA_EXTERN gchar* haguichi_utils_get_available_theme_icon (gchar** icon_names,
                                                gint icon_names_length1);
VALA_EXTERN gboolean haguichi_utils_path_exists (const gchar* type,
                                     const gchar* path);
VALA_EXTERN gchar* haguichi_command_return_output (const gchar* command);
VALA_EXTERN gchar* haguichi_utils_get_debug_info (void);
VALA_EXTERN gboolean haguichi_command_exists (const gchar* command);
VALA_EXTERN HaguichiUtils* haguichi_utils_new (void);
VALA_EXTERN HaguichiUtils* haguichi_utils_construct (GType object_type);
static GType haguichi_utils_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 124 "utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 128 "utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 134 "utils.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 138 "utils.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 142 "utils.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 150 "utils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 178 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 187 "utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 201 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 210 "utils.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 224 "utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 233 "utils.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 242 "utils.c"
}

gchar*
haguichi_utils_remove_mnemonics (gchar* label)
{
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 15 "../src/utils.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 253 "utils.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 17 "../src/utils.vala"
		_tmp1_ = g_regex_new ("\\(_[a-zA-Z]\\)", 0, 0, &_inner_error0_);
#line 17 "../src/utils.vala"
		_tmp0_ = _tmp1_;
#line 17 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17 "../src/utils.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 269 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 17 "../src/utils.vala"
			_g_free0 (label);
#line 17 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 17 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 17 "../src/utils.vala"
			return NULL;
#line 280 "utils.c"
		}
#line 17 "../src/utils.vala"
		_tmp3_ = g_regex_replace (_tmp0_, label, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 17 "../src/utils.vala"
		_tmp2_ = _tmp3_;
#line 17 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17 "../src/utils.vala"
			_g_regex_unref0 (_tmp0_);
#line 17 "../src/utils.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 292 "utils.c"
				goto __catch0_g_regex_error;
			}
#line 17 "../src/utils.vala"
			_g_free0 (label);
#line 17 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 17 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 17 "../src/utils.vala"
			return NULL;
#line 303 "utils.c"
		}
#line 17 "../src/utils.vala"
		_tmp4_ = _tmp2_;
#line 17 "../src/utils.vala"
		_tmp2_ = NULL;
#line 17 "../src/utils.vala"
		_g_free0 (label);
#line 17 "../src/utils.vala"
		label = _tmp4_;
#line 18 "../src/utils.vala"
		_tmp5_ = string_replace (label, "_", "");
#line 18 "../src/utils.vala"
		_g_free0 (label);
#line 18 "../src/utils.vala"
		label = _tmp5_;
#line 16 "../src/utils.vala"
		_g_free0 (_tmp2_);
#line 16 "../src/utils.vala"
		_g_regex_unref0 (_tmp0_);
#line 323 "utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 16 "../src/utils.vala"
		e = _inner_error0_;
#line 16 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 20 "../src/utils.vala"
		_tmp6_ = e;
#line 20 "../src/utils.vala"
		_tmp7_ = _tmp6_->message;
#line 20 "../src/utils.vala"
		g_critical ("utils.vala:20: remove_mnemonics: %s", _tmp7_);
#line 16 "../src/utils.vala"
		_g_error_free0 (e);
#line 343 "utils.c"
	}
	__finally0:
#line 16 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16 "../src/utils.vala"
		_g_free0 (label);
#line 16 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 16 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 16 "../src/utils.vala"
		return NULL;
#line 356 "utils.c"
	}
#line 23 "../src/utils.vala"
	_tmp8_ = g_strdup (label);
#line 23 "../src/utils.vala"
	result = _tmp8_;
#line 23 "../src/utils.vala"
	_g_free0 (label);
#line 23 "../src/utils.vala"
	return result;
#line 366 "utils.c"
}

gchar*
haguichi_utils_clean_string (gchar* _string)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 26 "../src/utils.vala"
	g_return_val_if_fail (_string != NULL, NULL);
#line 27 "../src/utils.vala"
	_tmp0_ = string_replace (_string, "\\", "\\\\");
#line 27 "../src/utils.vala"
	_g_free0 (_string);
#line 27 "../src/utils.vala"
	_string = _tmp0_;
#line 28 "../src/utils.vala"
	_tmp1_ = string_replace (_string, "\"", "\\\"");
#line 28 "../src/utils.vala"
	_g_free0 (_string);
#line 28 "../src/utils.vala"
	_string = _tmp1_;
#line 30 "../src/utils.vala"
	_tmp2_ = g_strdup (_string);
#line 30 "../src/utils.vala"
	result = _tmp2_;
#line 30 "../src/utils.vala"
	_g_free0 (_string);
#line 30 "../src/utils.vala"
	return result;
#line 398 "utils.c"
}

gchar*
haguichi_utils_parse_nick (const gchar* nick)
{
	gchar* parsed_nick = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 33 "../src/utils.vala"
	g_return_val_if_fail (nick != NULL, NULL);
#line 34 "../src/utils.vala"
	_tmp0_ = g_strdup (nick);
#line 34 "../src/utils.vala"
	parsed_nick = _tmp0_;
#line 36 "../src/utils.vala"
	if (g_strcmp0 (nick, "%USERNAME") == 0) {
#line 415 "utils.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 37 "../src/utils.vala"
		_tmp1_ = g_get_user_name ();
#line 37 "../src/utils.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 37 "../src/utils.vala"
		_g_free0 (parsed_nick);
#line 37 "../src/utils.vala"
		parsed_nick = _tmp2_;
#line 426 "utils.c"
	} else {
#line 38 "../src/utils.vala"
		if (g_strcmp0 (nick, "%REALNAME") == 0) {
#line 430 "utils.c"
			const gchar* _tmp3_;
			gchar* _tmp4_;
#line 39 "../src/utils.vala"
			_tmp3_ = g_get_real_name ();
#line 39 "../src/utils.vala"
			_tmp4_ = g_strdup (_tmp3_);
#line 39 "../src/utils.vala"
			_g_free0 (parsed_nick);
#line 39 "../src/utils.vala"
			parsed_nick = _tmp4_;
#line 441 "utils.c"
		} else {
#line 40 "../src/utils.vala"
			if (g_strcmp0 (nick, "%HOSTNAME") == 0) {
#line 445 "utils.c"
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 41 "../src/utils.vala"
				_tmp5_ = g_get_host_name ();
#line 41 "../src/utils.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 41 "../src/utils.vala"
				_g_free0 (parsed_nick);
#line 41 "../src/utils.vala"
				parsed_nick = _tmp6_;
#line 456 "utils.c"
			}
		}
	}
#line 44 "../src/utils.vala"
	result = parsed_nick;
#line 44 "../src/utils.vala"
	return result;
#line 464 "utils.c"
}

GtkIconTheme*
haguichi_utils_get_icon_theme (void)
{
	GdkDisplay* _tmp0_;
	GtkIconTheme* _tmp1_;
	GtkIconTheme* result;
#line 48 "../src/utils.vala"
	_tmp0_ = gdk_display_get_default ();
#line 48 "../src/utils.vala"
	_tmp1_ = gtk_icon_theme_get_for_display (_tmp0_);
#line 48 "../src/utils.vala"
	result = _tmp1_;
#line 48 "../src/utils.vala"
	return result;
#line 481 "utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 489 "utils.c"
}

gchar*
haguichi_utils_get_available_theme_icon (gchar** icon_names,
                                         gint icon_names_length1)
{
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 52 "../src/utils.vala"
	_tmp0_ = haguichi_utils_get_icon_theme ();
#line 52 "../src/utils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 52 "../src/utils.vala"
	icon_theme = _tmp1_;
#line 508 "utils.c"
	{
		gchar** icon_name_collection = NULL;
		gint icon_name_collection_length1 = 0;
		gint _icon_name_collection_size_ = 0;
		gint icon_name_it = 0;
#line 55 "../src/utils.vala"
		icon_name_collection = icon_names;
#line 55 "../src/utils.vala"
		icon_name_collection_length1 = icon_names_length1;
#line 55 "../src/utils.vala"
		for (icon_name_it = 0; icon_name_it < icon_name_collection_length1; icon_name_it = icon_name_it + 1) {
#line 520 "utils.c"
			gchar* _tmp2_;
			gchar* icon_name = NULL;
#line 55 "../src/utils.vala"
			_tmp2_ = g_strdup (icon_name_collection[icon_name_it]);
#line 55 "../src/utils.vala"
			icon_name = _tmp2_;
#line 527 "utils.c"
			{
				GtkIconTheme* _tmp3_;
				const gchar* _tmp4_;
#line 56 "../src/utils.vala"
				_tmp3_ = icon_theme;
#line 56 "../src/utils.vala"
				_tmp4_ = icon_name;
#line 56 "../src/utils.vala"
				if (gtk_icon_theme_has_icon (_tmp3_, _tmp4_)) {
#line 57 "../src/utils.vala"
					result = icon_name;
#line 57 "../src/utils.vala"
					_g_object_unref0 (icon_theme);
#line 57 "../src/utils.vala"
					return result;
#line 543 "utils.c"
				}
#line 55 "../src/utils.vala"
				_g_free0 (icon_name);
#line 547 "utils.c"
			}
		}
	}
#line 62 "../src/utils.vala"
	_tmp5_ = icon_names[0];
#line 62 "../src/utils.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 62 "../src/utils.vala"
	result = _tmp6_;
#line 62 "../src/utils.vala"
	_g_object_unref0 (icon_theme);
#line 62 "../src/utils.vala"
	return result;
#line 561 "utils.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 570 "utils.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 578 "utils.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 587 "utils.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 607 "utils.c"
}

gboolean
haguichi_utils_path_exists (const gchar* type,
                            const gchar* path)
{
	gboolean _result_ = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result;
#line 65 "../src/utils.vala"
	g_return_val_if_fail (type != NULL, FALSE);
#line 65 "../src/utils.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 66 "../src/utils.vala"
	_result_ = g_file_test (path, G_FILE_TEST_EXISTS);
#line 67 "../src/utils.vala"
	_tmp0_ = bool_to_string (_result_);
#line 67 "../src/utils.vala"
	_tmp1_ = _tmp0_;
#line 67 "../src/utils.vala"
	g_debug ("utils.vala:67: path_exists: FileUtils tested %s for path %s", _tmp1_, path);
#line 67 "../src/utils.vala"
	_g_free0 (_tmp1_);
#line 69 "../src/utils.vala"
	if (_result_) {
#line 70 "../src/utils.vala"
		result = TRUE;
#line 70 "../src/utils.vala"
		return result;
#line 638 "utils.c"
	}
#line 73 "../src/utils.vala"
	if (xdp_portal_running_under_flatpak ()) {
#line 642 "utils.c"
		gchar* output = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 74 "../src/utils.vala"
		_tmp2_ = g_strdup_printf ("bash -c \"test -%s %s &>/dev/null || echo 'path not found'\"", type, path);
#line 74 "../src/utils.vala"
		_tmp3_ = _tmp2_;
#line 74 "../src/utils.vala"
		_tmp4_ = haguichi_command_return_output (_tmp3_);
#line 74 "../src/utils.vala"
		_tmp5_ = _tmp4_;
#line 74 "../src/utils.vala"
		_g_free0 (_tmp3_);
#line 74 "../src/utils.vala"
		output = _tmp5_;
#line 75 "../src/utils.vala"
		_tmp6_ = output;
#line 75 "../src/utils.vala"
		g_debug ("utils.vala:75: path_exists test output: %s", _tmp6_);
#line 77 "../src/utils.vala"
		_tmp7_ = output;
#line 77 "../src/utils.vala"
		if (!string_contains (_tmp7_, "path not found")) {
#line 78 "../src/utils.vala"
			result = TRUE;
#line 78 "../src/utils.vala"
			_g_free0 (output);
#line 78 "../src/utils.vala"
			return result;
#line 676 "utils.c"
		}
#line 73 "../src/utils.vala"
		_g_free0 (output);
#line 680 "utils.c"
	}
#line 82 "../src/utils.vala"
	g_debug ("utils.vala:82: path_exists: Path %s was not found", path);
#line 83 "../src/utils.vala"
	result = FALSE;
#line 83 "../src/utils.vala"
	return result;
#line 688 "utils.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 709 "utils.c"
}

static gchar*
string_chug (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1405 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1406 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1406 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1407 "glib-2.0.vapi"
	g_strchug (_result_);
#line 1408 "glib-2.0.vapi"
	result = _result_;
#line 1408 "glib-2.0.vapi"
	return result;
#line 730 "utils.c"
}

gchar*
haguichi_utils_get_debug_info (void)
{
	gchar* kernel = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* distro = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* codename = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* initsys = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* engine = NULL;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_ = NULL;
	const gchar* _tmp21_;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_;
	const gchar* _tmp26_ = NULL;
	const gchar* _tmp27_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* result;
#line 87 "../src/utils.vala"
	_tmp0_ = haguichi_command_return_output ("uname -sri");
#line 87 "../src/utils.vala"
	_tmp1_ = _tmp0_;
#line 87 "../src/utils.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 87 "../src/utils.vala"
	_tmp3_ = _tmp2_;
#line 87 "../src/utils.vala"
	_g_free0 (_tmp1_);
#line 87 "../src/utils.vala"
	kernel = _tmp3_;
#line 88 "../src/utils.vala"
	_tmp4_ = haguichi_command_return_output ("lsb_release -ds");
#line 88 "../src/utils.vala"
	_tmp5_ = _tmp4_;
#line 88 "../src/utils.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 88 "../src/utils.vala"
	_tmp7_ = _tmp6_;
#line 88 "../src/utils.vala"
	_g_free0 (_tmp5_);
#line 88 "../src/utils.vala"
	distro = _tmp7_;
#line 89 "../src/utils.vala"
	_tmp8_ = haguichi_command_return_output ("lsb_release -cs");
#line 89 "../src/utils.vala"
	_tmp9_ = _tmp8_;
#line 89 "../src/utils.vala"
	_tmp10_ = string_strip (_tmp9_);
#line 89 "../src/utils.vala"
	_tmp11_ = _tmp10_;
#line 89 "../src/utils.vala"
	_g_free0 (_tmp9_);
#line 89 "../src/utils.vala"
	codename = _tmp11_;
#line 90 "../src/utils.vala"
	_tmp12_ = haguichi_command_return_output ("ps -p 1 -o comm=");
#line 90 "../src/utils.vala"
	_tmp13_ = _tmp12_;
#line 90 "../src/utils.vala"
	_tmp14_ = string_strip (_tmp13_);
#line 90 "../src/utils.vala"
	_tmp15_ = _tmp14_;
#line 90 "../src/utils.vala"
	_g_free0 (_tmp13_);
#line 90 "../src/utils.vala"
	initsys = _tmp15_;
#line 91 "../src/utils.vala"
	_tmp16_ = g_strdup_printf ("cat %s", HAGUICHI_HAMACHI_CONFIG_PATH);
#line 91 "../src/utils.vala"
	_tmp17_ = _tmp16_;
#line 91 "../src/utils.vala"
	_tmp18_ = haguichi_command_return_output (_tmp17_);
#line 91 "../src/utils.vala"
	_tmp19_ = _tmp18_;
#line 91 "../src/utils.vala"
	_g_free0 (_tmp17_);
#line 91 "../src/utils.vala"
	engine = _tmp19_;
#line 135 "../src/utils.vala"
	_tmp21_ = haguichi_command_terminal;
#line 135 "../src/utils.vala"
	if (haguichi_command_exists (_tmp21_)) {
#line 862 "utils.c"
		const gchar* _tmp22_;
#line 135 "../src/utils.vala"
		_tmp22_ = haguichi_command_terminal;
#line 135 "../src/utils.vala"
		_tmp20_ = _tmp22_;
#line 868 "utils.c"
	} else {
#line 135 "../src/utils.vala"
		_tmp20_ = NULL;
#line 872 "utils.c"
	}
#line 136 "../src/utils.vala"
	_tmp24_ = haguichi_command_file_manager;
#line 136 "../src/utils.vala"
	if (haguichi_command_exists (_tmp24_)) {
#line 878 "utils.c"
		const gchar* _tmp25_;
#line 136 "../src/utils.vala"
		_tmp25_ = haguichi_command_file_manager;
#line 136 "../src/utils.vala"
		_tmp23_ = _tmp25_;
#line 884 "utils.c"
	} else {
#line 136 "../src/utils.vala"
		_tmp23_ = NULL;
#line 888 "utils.c"
	}
#line 137 "../src/utils.vala"
	_tmp27_ = haguichi_command_remote_desktop;
#line 137 "../src/utils.vala"
	if (haguichi_command_exists (_tmp27_)) {
#line 894 "utils.c"
		const gchar* _tmp28_;
#line 137 "../src/utils.vala"
		_tmp28_ = haguichi_command_remote_desktop;
#line 137 "../src/utils.vala"
		_tmp26_ = _tmp28_;
#line 900 "utils.c"
	} else {
#line 137 "../src/utils.vala"
		_tmp26_ = NULL;
#line 904 "utils.c"
	}
#line 93 "../src/utils.vala"
	_tmp29_ = distro;
#line 93 "../src/utils.vala"
	_tmp30_ = codename;
#line 93 "../src/utils.vala"
	_tmp31_ = kernel;
#line 93 "../src/utils.vala"
	_tmp32_ = g_strdup_printf ("%u", GLIB_MAJOR_VERSION);
#line 93 "../src/utils.vala"
	_tmp33_ = _tmp32_;
#line 93 "../src/utils.vala"
	_tmp34_ = g_strdup_printf ("%u", GLIB_MINOR_VERSION);
#line 93 "../src/utils.vala"
	_tmp35_ = _tmp34_;
#line 93 "../src/utils.vala"
	_tmp36_ = g_strdup_printf ("%u", GLIB_MICRO_VERSION);
#line 93 "../src/utils.vala"
	_tmp37_ = _tmp36_;
#line 93 "../src/utils.vala"
	_tmp38_ = g_strdup_printf ("%i", GTK_MAJOR_VERSION);
#line 93 "../src/utils.vala"
	_tmp39_ = _tmp38_;
#line 93 "../src/utils.vala"
	_tmp40_ = g_strdup_printf ("%i", GTK_MINOR_VERSION);
#line 93 "../src/utils.vala"
	_tmp41_ = _tmp40_;
#line 93 "../src/utils.vala"
	_tmp42_ = g_strdup_printf ("%i", GTK_MICRO_VERSION);
#line 93 "../src/utils.vala"
	_tmp43_ = _tmp42_;
#line 93 "../src/utils.vala"
	_tmp44_ = g_getenv ("LANG");
#line 93 "../src/utils.vala"
	_tmp45_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 93 "../src/utils.vala"
	_tmp46_ = g_getenv ("XDG_SESSION_TYPE");
#line 93 "../src/utils.vala"
	_tmp47_ = bool_to_string (xdp_portal_running_under_flatpak ());
#line 93 "../src/utils.vala"
	_tmp48_ = _tmp47_;
#line 93 "../src/utils.vala"
	_tmp49_ = haguichi_hamachi_version;
#line 93 "../src/utils.vala"
	_tmp50_ = haguichi_hamachi_ip_version;
#line 93 "../src/utils.vala"
	_tmp51_ = haguichi_hamachi_service;
#line 93 "../src/utils.vala"
	_tmp52_ = initsys;
#line 93 "../src/utils.vala"
	_tmp53_ = haguichi_command_sudo;
#line 93 "../src/utils.vala"
	_tmp54_ = engine;
#line 93 "../src/utils.vala"
	_tmp55_ = g_strdup_printf ("\n" \
"Haguichi: %s\n" \
"Distribution: %s\n" \
"Codename: %s\n" \
"Kernel: %s\n" \
"GLib: %s.%s.%s\n" \
"GTK: %s.%s.%s\n" \
"Adwaita: %s\n" \
"Locale: %s\n" \
"Desktop: %s\n" \
"Session: %s\n" \
"Flatpak: %s\n" \
"Hamachi: %s\n" \
"IP mode: %s\n" \
"Service: %s\n" \
"Init: %s\n" \
"Sudo: %s\n" \
"Terminal: %s\n" \
"File manager: %s\n" \
"Remote desktop: %s\n" \
"Engine override:\n" \
"%s", CONFIG_VERSION, _tmp29_, _tmp30_, _tmp31_, _tmp33_, _tmp35_, _tmp37_, _tmp39_, _tmp41_, _tmp43_, ADW_VERSION_S, _tmp44_, _tmp45_, _tmp46_, _tmp48_, _tmp49_, _tmp50_, _tmp51_, _tmp52_, _tmp53_, _tmp20_, _tmp23_, _tmp26_, _tmp54_);
#line 93 "../src/utils.vala"
	_tmp56_ = _tmp55_;
#line 93 "../src/utils.vala"
	_tmp57_ = string_chug (_tmp56_);
#line 93 "../src/utils.vala"
	_tmp58_ = _tmp57_;
#line 93 "../src/utils.vala"
	_g_free0 (_tmp56_);
#line 93 "../src/utils.vala"
	_g_free0 (_tmp48_);
#line 93 "../src/utils.vala"
	_g_free0 (_tmp43_);
#line 93 "../src/utils.vala"
	_g_free0 (_tmp41_);
#line 93 "../src/utils.vala"
	_g_free0 (_tmp39_);
#line 93 "../src/utils.vala"
	_g_free0 (_tmp37_);
#line 93 "../src/utils.vala"
	_g_free0 (_tmp35_);
#line 93 "../src/utils.vala"
	_g_free0 (_tmp33_);
#line 93 "../src/utils.vala"
	result = _tmp58_;
#line 93 "../src/utils.vala"
	_g_free0 (engine);
#line 93 "../src/utils.vala"
	_g_free0 (initsys);
#line 93 "../src/utils.vala"
	_g_free0 (codename);
#line 93 "../src/utils.vala"
	_g_free0 (distro);
#line 93 "../src/utils.vala"
	_g_free0 (kernel);
#line 93 "../src/utils.vala"
	return result;
#line 996 "utils.c"
}

HaguichiUtils*
haguichi_utils_construct (GType object_type)
{
	HaguichiUtils * self = NULL;
#line 14 "../src/utils.vala"
	self = (HaguichiUtils*) g_object_new (object_type, NULL);
#line 14 "../src/utils.vala"
	return self;
#line 1007 "utils.c"
}

HaguichiUtils*
haguichi_utils_new (void)
{
#line 14 "../src/utils.vala"
	return haguichi_utils_construct (HAGUICHI_TYPE_UTILS);
#line 1015 "utils.c"
}

static void
haguichi_utils_class_init (HaguichiUtilsClass * klass,
                           gpointer klass_data)
{
#line 14 "../src/utils.vala"
	haguichi_utils_parent_class = g_type_class_peek_parent (klass);
#line 1024 "utils.c"
}

static void
haguichi_utils_instance_init (HaguichiUtils * self,
                              gpointer klass)
{
}

static GType
haguichi_utils_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiUtils), 0, (GInstanceInitFunc) haguichi_utils_instance_init, NULL };
	GType haguichi_utils_type_id;
	haguichi_utils_type_id = g_type_register_static (G_TYPE_OBJECT, "HaguichiUtils", &g_define_type_info, 0);
	return haguichi_utils_type_id;
}

GType
haguichi_utils_get_type (void)
{
	static volatile gsize haguichi_utils_type_id__once = 0;
	if (g_once_init_enter (&haguichi_utils_type_id__once)) {
		GType haguichi_utils_type_id;
		haguichi_utils_type_id = haguichi_utils_get_type_once ();
		g_once_init_leave (&haguichi_utils_type_id__once, haguichi_utils_type_id);
	}
	return haguichi_utils_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

