/* throbber.c generated by valac 0.56.18, the Vala compiler
 * generated from throbber.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_THROBBER (haguichi_throbber_get_type ())
#define HAGUICHI_THROBBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_THROBBER, HaguichiThrobber))
#define HAGUICHI_THROBBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_THROBBER, HaguichiThrobberClass))
#define HAGUICHI_IS_THROBBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_THROBBER))
#define HAGUICHI_IS_THROBBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_THROBBER))
#define HAGUICHI_THROBBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_THROBBER, HaguichiThrobberClass))

typedef struct _HaguichiThrobber HaguichiThrobber;
typedef struct _HaguichiThrobberClass HaguichiThrobberClass;
typedef struct _HaguichiThrobberPrivate HaguichiThrobberPrivate;
enum  {
	HAGUICHI_THROBBER_0_PROPERTY,
	HAGUICHI_THROBBER_SPINNING_PROPERTY,
	HAGUICHI_THROBBER_NUM_PROPERTIES
};
static GParamSpec* haguichi_throbber_properties[HAGUICHI_THROBBER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HaguichiThrobber {
	AdwBin parent_instance;
	HaguichiThrobberPrivate * priv;
	GtkSpinner* spinner;
};

struct _HaguichiThrobberClass {
	AdwBinClass parent_class;
};

static gpointer haguichi_throbber_parent_class = NULL;

VALA_EXTERN GType haguichi_throbber_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiThrobber, g_object_unref)
VALA_EXTERN HaguichiThrobber* haguichi_throbber_new (void);
VALA_EXTERN HaguichiThrobber* haguichi_throbber_construct (GType object_type);
VALA_EXTERN gboolean haguichi_throbber_get_spinning (HaguichiThrobber* self);
VALA_EXTERN void haguichi_throbber_set_spinning (HaguichiThrobber* self,
                                     gboolean value);
static GObject * haguichi_throbber_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void haguichi_throbber_finalize (GObject * obj);
static GType haguichi_throbber_get_type_once (void);
static void _vala_haguichi_throbber_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_haguichi_throbber_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

HaguichiThrobber*
haguichi_throbber_construct (GType object_type)
{
	HaguichiThrobber * self = NULL;
#line 20 "../src/widgets/throbber.vala"
	self = (HaguichiThrobber*) g_object_new (object_type, NULL);
#line 20 "../src/widgets/throbber.vala"
	return self;
#line 102 "throbber.c"
}

HaguichiThrobber*
haguichi_throbber_new (void)
{
#line 20 "../src/widgets/throbber.vala"
	return haguichi_throbber_construct (HAGUICHI_TYPE_THROBBER);
#line 110 "throbber.c"
}

gboolean
haguichi_throbber_get_spinning (HaguichiThrobber* self)
{
	gboolean result;
	GtkSpinner* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 35 "../src/widgets/throbber.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/widgets/throbber.vala"
	_tmp0_ = self->spinner;
#line 36 "../src/widgets/throbber.vala"
	_tmp1_ = gtk_spinner_get_spinning (_tmp0_);
#line 36 "../src/widgets/throbber.vala"
	_tmp2_ = _tmp1_;
#line 36 "../src/widgets/throbber.vala"
	result = _tmp2_;
#line 36 "../src/widgets/throbber.vala"
	return result;
#line 132 "throbber.c"
}

void
haguichi_throbber_set_spinning (HaguichiThrobber* self,
                                gboolean value)
{
	GtkSpinner* _tmp0_;
#line 38 "../src/widgets/throbber.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/widgets/throbber.vala"
	_tmp0_ = self->spinner;
#line 39 "../src/widgets/throbber.vala"
	gtk_spinner_set_spinning (_tmp0_, value);
#line 38 "../src/widgets/throbber.vala"
	g_object_notify_by_pspec ((GObject *) self, haguichi_throbber_properties[HAGUICHI_THROBBER_SPINNING_PROPERTY]);
#line 148 "throbber.c"
}

static GObject *
haguichi_throbber_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HaguichiThrobber * self;
	GtkSpinner* _tmp0_ = NULL;
	GtkSpinner* _tmp1_;
#line 23 "../src/widgets/throbber.vala"
	parent_class = G_OBJECT_CLASS (haguichi_throbber_parent_class);
#line 23 "../src/widgets/throbber.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 23 "../src/widgets/throbber.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_THROBBER, HaguichiThrobber);
#line 24 "../src/widgets/throbber.vala"
	_tmp0_ = (GtkSpinner*) gtk_spinner_new ();
#line 24 "../src/widgets/throbber.vala"
	g_object_set ((GtkWidget*) _tmp0_, "width-request", 20, NULL);
#line 24 "../src/widgets/throbber.vala"
	g_object_set ((GtkWidget*) _tmp0_, "height-request", 20, NULL);
#line 24 "../src/widgets/throbber.vala"
	g_object_ref_sink (_tmp0_);
#line 24 "../src/widgets/throbber.vala"
	_g_object_unref0 (self->spinner);
#line 24 "../src/widgets/throbber.vala"
	self->spinner = _tmp0_;
#line 28 "../src/widgets/throbber.vala"
	_tmp1_ = self->spinner;
#line 28 "../src/widgets/throbber.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp1_);
#line 23 "../src/widgets/throbber.vala"
	return obj;
#line 185 "throbber.c"
}

static void
haguichi_throbber_class_init (HaguichiThrobberClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/widgets/throbber.vala"
	haguichi_throbber_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/widgets/throbber.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_haguichi_throbber_get_property;
#line 20 "../src/widgets/throbber.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_haguichi_throbber_set_property;
#line 20 "../src/widgets/throbber.vala"
	G_OBJECT_CLASS (klass)->constructor = haguichi_throbber_constructor;
#line 20 "../src/widgets/throbber.vala"
	G_OBJECT_CLASS (klass)->finalize = haguichi_throbber_finalize;
#line 20 "../src/widgets/throbber.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HAGUICHI_THROBBER_SPINNING_PROPERTY, haguichi_throbber_properties[HAGUICHI_THROBBER_SPINNING_PROPERTY] = g_param_spec_boolean ("spinning", "spinning", "spinning", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 204 "throbber.c"
}

static void
haguichi_throbber_instance_init (HaguichiThrobber * self,
                                 gpointer klass)
{
}

static void
haguichi_throbber_finalize (GObject * obj)
{
	HaguichiThrobber * self;
#line 20 "../src/widgets/throbber.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_THROBBER, HaguichiThrobber);
#line 21 "../src/widgets/throbber.vala"
	_g_object_unref0 (self->spinner);
#line 20 "../src/widgets/throbber.vala"
	G_OBJECT_CLASS (haguichi_throbber_parent_class)->finalize (obj);
#line 223 "throbber.c"
}

static GType
haguichi_throbber_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiThrobberClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_throbber_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiThrobber), 0, (GInstanceInitFunc) haguichi_throbber_instance_init, NULL };
	GType haguichi_throbber_type_id;
	haguichi_throbber_type_id = g_type_register_static (adw_bin_get_type (), "HaguichiThrobber", &g_define_type_info, 0);
	return haguichi_throbber_type_id;
}

GType
haguichi_throbber_get_type (void)
{
	static volatile gsize haguichi_throbber_type_id__once = 0;
	if (g_once_init_enter (&haguichi_throbber_type_id__once)) {
		GType haguichi_throbber_type_id;
		haguichi_throbber_type_id = haguichi_throbber_get_type_once ();
		g_once_init_leave (&haguichi_throbber_type_id__once, haguichi_throbber_type_id);
	}
	return haguichi_throbber_type_id__once;
}

static void
_vala_haguichi_throbber_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	HaguichiThrobber * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HAGUICHI_TYPE_THROBBER, HaguichiThrobber);
#line 20 "../src/widgets/throbber.vala"
	switch (property_id) {
#line 20 "../src/widgets/throbber.vala"
		case HAGUICHI_THROBBER_SPINNING_PROPERTY:
#line 20 "../src/widgets/throbber.vala"
		g_value_set_boolean (value, haguichi_throbber_get_spinning (self));
#line 20 "../src/widgets/throbber.vala"
		break;
#line 263 "throbber.c"
		default:
#line 20 "../src/widgets/throbber.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/widgets/throbber.vala"
		break;
#line 269 "throbber.c"
	}
}

static void
_vala_haguichi_throbber_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	HaguichiThrobber * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HAGUICHI_TYPE_THROBBER, HaguichiThrobber);
#line 20 "../src/widgets/throbber.vala"
	switch (property_id) {
#line 20 "../src/widgets/throbber.vala"
		case HAGUICHI_THROBBER_SPINNING_PROPERTY:
#line 20 "../src/widgets/throbber.vala"
		haguichi_throbber_set_spinning (self, g_value_get_boolean (value));
#line 20 "../src/widgets/throbber.vala"
		break;
#line 289 "throbber.c"
		default:
#line 20 "../src/widgets/throbber.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/widgets/throbber.vala"
		break;
#line 295 "throbber.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

