/* window.c generated by valac 0.56.18, the Vala compiler
 * generated from window.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2025 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libportal/portal.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <libportal-gtk4/portal-gtk4.h>

#define CONFIG_APP_NAME "Haguichi"
#define CONFIG_APP_ID "com.github.ztefn.haguichi"
#define CONFIG_VERSION "1.5.2"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))
#define HAGUICHI_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;
typedef struct _HaguichiWindowPrivate HaguichiWindowPrivate;

#define HAGUICHI_TYPE_SIDEBAR (haguichi_sidebar_get_type ())
#define HAGUICHI_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebar))
#define HAGUICHI_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebarClass))
#define HAGUICHI_IS_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_SIDEBAR))
#define HAGUICHI_IS_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_SIDEBAR))
#define HAGUICHI_SIDEBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebarClass))

typedef struct _HaguichiSidebar HaguichiSidebar;
typedef struct _HaguichiSidebarClass HaguichiSidebarClass;

#define HAGUICHI_TYPE_NETWORK_LIST (haguichi_network_list_get_type ())
#define HAGUICHI_NETWORK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkList))
#define HAGUICHI_NETWORK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkListClass))
#define HAGUICHI_IS_NETWORK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_NETWORK_LIST))
#define HAGUICHI_IS_NETWORK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_NETWORK_LIST))
#define HAGUICHI_NETWORK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkListClass))

typedef struct _HaguichiNetworkList HaguichiNetworkList;
typedef struct _HaguichiNetworkListClass HaguichiNetworkListClass;

#define HAGUICHI_TYPE_THROBBER (haguichi_throbber_get_type ())
#define HAGUICHI_THROBBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_THROBBER, HaguichiThrobber))
#define HAGUICHI_THROBBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_THROBBER, HaguichiThrobberClass))
#define HAGUICHI_IS_THROBBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_THROBBER))
#define HAGUICHI_IS_THROBBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_THROBBER))
#define HAGUICHI_THROBBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_THROBBER, HaguichiThrobberClass))

typedef struct _HaguichiThrobber HaguichiThrobber;
typedef struct _HaguichiThrobberClass HaguichiThrobberClass;
enum  {
	HAGUICHI_WINDOW_0_PROPERTY,
	HAGUICHI_WINDOW_NUM_PROPERTIES
};
static GParamSpec* haguichi_window_properties[HAGUICHI_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define HAGUICHI_TYPE_APPLICATION (haguichi_application_get_type ())
#define HAGUICHI_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplication))
#define HAGUICHI_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))
#define HAGUICHI_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))

typedef struct _HaguichiApplication HaguichiApplication;
typedef struct _HaguichiApplicationClass HaguichiApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define HAGUICHI_TYPE_INDICATOR (haguichi_indicator_get_type ())
#define HAGUICHI_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicator))
#define HAGUICHI_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))
#define HAGUICHI_IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))

typedef struct _HaguichiIndicator HaguichiIndicator;
typedef struct _HaguichiIndicatorClass HaguichiIndicatorClass;
#define _haguichi_indicator_unref0(var) ((var == NULL) ? NULL : (var = (haguichi_indicator_unref (var), NULL)))

#define HAGUICHI_TYPE_SESSION (haguichi_session_get_type ())
#define HAGUICHI_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_SESSION, HaguichiSession))
#define HAGUICHI_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_SESSION, HaguichiSessionClass))
#define HAGUICHI_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_SESSION))
#define HAGUICHI_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_SESSION))
#define HAGUICHI_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_SESSION, HaguichiSessionClass))

typedef struct _HaguichiSession HaguichiSession;
typedef struct _HaguichiSessionClass HaguichiSessionClass;

#define HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG (haguichi_join_create_network_dialog_get_type ())
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialog))
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialogClass))
#define HAGUICHI_IS_JOIN_CREATE_NETWORK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG))
#define HAGUICHI_IS_JOIN_CREATE_NETWORK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG))
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialogClass))

typedef struct _HaguichiJoinCreateNetworkDialog HaguichiJoinCreateNetworkDialog;
typedef struct _HaguichiJoinCreateNetworkDialogClass HaguichiJoinCreateNetworkDialogClass;

#define HAGUICHI_TYPE_ATTACH_DIALOG (haguichi_attach_dialog_get_type ())
#define HAGUICHI_ATTACH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialog))
#define HAGUICHI_ATTACH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialogClass))
#define HAGUICHI_IS_ATTACH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_ATTACH_DIALOG))
#define HAGUICHI_IS_ATTACH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_ATTACH_DIALOG))
#define HAGUICHI_ATTACH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialogClass))

typedef struct _HaguichiAttachDialog HaguichiAttachDialog;
typedef struct _HaguichiAttachDialogClass HaguichiAttachDialogClass;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

#define HAGUICHI_TYPE_PREFERENCES (haguichi_preferences_get_type ())
#define HAGUICHI_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferences))
#define HAGUICHI_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))
#define HAGUICHI_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))

typedef struct _HaguichiPreferences HaguichiPreferences;
typedef struct _HaguichiPreferencesClass HaguichiPreferencesClass;
typedef struct _Block28Data Block28Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define HAGUICHI_TYPE_CONNECTION (haguichi_connection_get_type ())
#define HAGUICHI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_CONNECTION, HaguichiConnection))
#define HAGUICHI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_CONNECTION, HaguichiConnectionClass))
#define HAGUICHI_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_CONNECTION))
#define HAGUICHI_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_CONNECTION))
#define HAGUICHI_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_CONNECTION, HaguichiConnectionClass))

typedef struct _HaguichiConnection HaguichiConnection;
typedef struct _HaguichiConnectionClass HaguichiConnectionClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _HaguichiSidebarPrivate HaguichiSidebarPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _HaguichiWindowSetBackgroundStatusData HaguichiWindowSetBackgroundStatusData;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define __vala_XdpParent_free0(var) ((var == NULL) ? NULL : (var = (_vala_XdpParent_free (var), NULL)))
typedef struct _HaguichiWindowRequestBackgroundData HaguichiWindowRequestBackgroundData;

struct _HaguichiWindow {
	AdwApplicationWindow parent_instance;
	HaguichiWindowPrivate * priv;
	AdwOverlaySplitView* split_view;
	AdwWindowTitle* window_title;
	AdwStatusPage* not_installed_status_page;
	HaguichiSidebar* sidebar;
	HaguichiNetworkList* network_list;
	GtkToggleButton* connect_button;
	GtkToggleButton* disconnect_button;
	GtkToggleButton* search_button;
	GtkSearchBar* search_bar;
	GtkSearchEntry* search_entry;
	GtkStack* stack;
	GtkStack* connected_stack;
	GtkStack* disconnected_stack;
	AdwStatusPage* restore_status_page;
	HaguichiThrobber* throbber;
	GtkWidget* modal_dialog;
};

struct _HaguichiWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _HaguichiWindowPrivate {
	AdwToastOverlay* toast_overlay;
	GtkButton* refresh_button;
	GtkButton* configure_button;
	GtkButton* overlay_refresh_button;
	GtkMenuButton* overlay_add_network_button;
	XdpPortal* portal;
};

struct _Block28Data {
	int _ref_count_;
	HaguichiWindow* self;
	AdwAboutDialog* about;
};

struct _HaguichiSidebar {
	AdwBin parent_instance;
	HaguichiSidebarPrivate * priv;
	GtkButton* attach_button;
	GtkButton* cancel_button;
	GtkButton* network_leave_button;
	GtkButton* network_delete_button;
	GtkButton* network_password_button;
	GtkButton* network_access_button;
	GtkButton* network_go_online_button;
	GtkButton* network_go_offline_button;
	GtkButton* member_approve_button;
	GtkButton* member_reject_button;
	GtkButton* member_evict_button;
};

struct _HaguichiSidebarClass {
	AdwBinClass parent_class;
};

struct _HaguichiWindowSetBackgroundStatusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HaguichiWindow* self;
	gboolean success;
	XdpPortal* _tmp0_;
	AdwWindowTitle* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

struct _HaguichiWindowRequestBackgroundData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HaguichiWindow* self;
	gboolean result;
	XdpParent* parent;
	XdpParent* _tmp0_;
	GPtrArray* command;
	GPtrArray* _tmp1_;
	gboolean _tmp2_;
	XdpPortal* _tmp3_;
	GPtrArray* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

static gint HaguichiWindow_private_offset;
static gpointer haguichi_window_parent_class = NULL;
VALA_EXTERN gboolean haguichi_demo_mode;
VALA_EXTERN HaguichiIndicator* haguichi_indicator;
VALA_EXTERN HaguichiSession* haguichi_session;
VALA_EXTERN gboolean haguichi_controller_restore;
VALA_EXTERN gint haguichi_controller_last_status;
VALA_EXTERN HaguichiConnection* haguichi_connection;
VALA_EXTERN HaguichiApplication* haguichi_app;
VALA_EXTERN gchar* haguichi_hamachi_version;

VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
VALA_EXTERN GType haguichi_sidebar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiSidebar, g_object_unref)
VALA_EXTERN GType haguichi_network_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiNetworkList, g_object_unref)
VALA_EXTERN GType haguichi_throbber_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiThrobber, g_object_unref)
VALA_EXTERN GType haguichi_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiApplication, g_object_unref)
VALA_EXTERN HaguichiWindow* haguichi_window_new (HaguichiApplication* app);
VALA_EXTERN HaguichiWindow* haguichi_window_construct (GType object_type,
                                           HaguichiApplication* app);
VALA_EXTERN gchar* haguichi_utils_parse_nick (const gchar* nick);
VALA_EXTERN void haguichi_window_set_nick (HaguichiWindow* self,
                               const gchar* nick);
VALA_EXTERN void haguichi_application_set_color_scheme (HaguichiApplication* self,
                                            gint scheme);
VALA_EXTERN HaguichiIndicator* haguichi_indicator_new (void);
VALA_EXTERN HaguichiIndicator* haguichi_indicator_construct (GType object_type);
VALA_EXTERN gpointer haguichi_indicator_ref (gpointer instance);
VALA_EXTERN void haguichi_indicator_unref (gpointer instance);
VALA_EXTERN GParamSpec* haguichi_param_spec_indicator (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void haguichi_value_set_indicator (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void haguichi_value_take_indicator (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer haguichi_value_get_indicator (const GValue* value);
VALA_EXTERN GType haguichi_indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiIndicator, haguichi_indicator_unref)
VALA_EXTERN void haguichi_indicator_set_active (HaguichiIndicator* self,
                                    gboolean value);
VALA_EXTERN void haguichi_window_update_indicator_status (HaguichiWindow* self);
static void __lambda106_ (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_refilter (HaguichiNetworkList* self);
static void ___lambda106__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                    gpointer self);
static void __lambda107_ (HaguichiWindow* self);
VALA_EXTERN GType haguichi_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiSession, g_object_unref)
VALA_EXTERN guint haguichi_session_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
static void ___lambda107__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
static void __lambda108_ (HaguichiWindow* self);
static void ___lambda108__gtk_widget_show (GtkWidget* _sender,
                                    gpointer self);
static void haguichi_window_download_hamachi (HaguichiWindow* self);
VALA_EXTERN void haguichi_command_open_redirect_uri (const gchar* action);
static void _haguichi_window_download_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void haguichi_window_configure_hamachi (HaguichiWindow* self);
VALA_EXTERN void haguichi_hamachi_configure (void);
static void _haguichi_window_configure_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void haguichi_window_cancel_restore (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_connection_stopped (void);
VALA_EXTERN void haguichi_network_list_clear_state (HaguichiNetworkList* self);
static void _haguichi_window_cancel_restore_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self);
static void haguichi_window_go_back_button_clicked (HaguichiWindow* self);
static void _haguichi_window_go_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void haguichi_window_connect_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_start_hamachi (void);
static void haguichi_window_disconnect_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_stop_hamachi (void);
static void haguichi_window_join_network_action (HaguichiWindow* self);
static void haguichi_window_add_network_action (HaguichiWindow* self,
                                         const gchar* mode);
static void haguichi_window_create_network_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_join_create_network_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiJoinCreateNetworkDialog, g_object_unref)
VALA_EXTERN HaguichiJoinCreateNetworkDialog* haguichi_join_create_network_dialog_new (const gchar* _mode);
VALA_EXTERN HaguichiJoinCreateNetworkDialog* haguichi_join_create_network_dialog_construct (GType object_type,
                                                                                const gchar* _mode);
VALA_EXTERN void haguichi_window_show_dialog (HaguichiWindow* self,
                                  GtkWidget* widget);
static void haguichi_window_attach_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_attach_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiAttachDialog, g_object_unref)
VALA_EXTERN HaguichiAttachDialog* haguichi_attach_dialog_new (void);
VALA_EXTERN HaguichiAttachDialog* haguichi_attach_dialog_construct (GType object_type);
static void haguichi_window_attach_cancel_action (HaguichiWindow* self);
static void* __lambda119_ (HaguichiWindow* self);
VALA_EXTERN gchar* haguichi_hamachi_cancel (void);
static gpointer ___lambda119__gthread_func (gpointer self);
VALA_EXTERN void haguichi_sidebar_set_account (HaguichiSidebar* self,
                                   const gchar* account);
static void haguichi_window_start_search_action (HaguichiWindow* self);
static void haguichi_window_refresh_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_init (void);
VALA_EXTERN void haguichi_controller_update_connection (void);
static void haguichi_window_toggle_sidebar_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_toggle_sidebar (HaguichiWindow* self);
static void haguichi_window_cycle_mode_action (HaguichiWindow* self);
VALA_EXTERN gchar* haguichi_window_get_mode (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_set_mode (HaguichiWindow* self,
                               const gchar* mode);
static void haguichi_window_expand_all_networks_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_set_all_rows_expanded (HaguichiNetworkList* self,
                                                  gboolean expanded);
static void haguichi_window_collapse_all_networks_action (HaguichiWindow* self);
static void haguichi_window_preferences_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiPreferences, g_object_unref)
VALA_EXTERN HaguichiPreferences* haguichi_preferences_new (void);
VALA_EXTERN HaguichiPreferences* haguichi_preferences_construct (GType object_type);
static void haguichi_window_shortcuts_action (HaguichiWindow* self);
static void haguichi_window_help_action (HaguichiWindow* self);
static void haguichi_window_info_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_show_info (HaguichiWindow* self);
static void haguichi_window_about_action (HaguichiWindow* self);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void* __lambda136_ (Block28Data* _data28_);
VALA_EXTERN gchar* haguichi_utils_get_debug_info (void);
static gpointer ___lambda136__gthread_func (gpointer self);
static void haguichi_window_quit_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_quit (void);
VALA_EXTERN GType haguichi_connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiConnection, g_object_unref)
VALA_EXTERN void haguichi_connection_save_long_nicks (HaguichiConnection* self);
VALA_EXTERN void haguichi_window_trigger_action (HaguichiWindow* self,
                                     const gchar* action_name);
static gboolean ___lambda90_ (HaguichiWindow* self);
static void haguichi_window_set_modal_dialog (HaguichiWindow* self,
                                       GtkWidget* dialog);
static gboolean ____lambda90__gtk_window_close_request (GtkWindow* _sender,
                                                 gpointer self);
static void ____lambda91_ (HaguichiWindow* self);
static void _____lambda91__adw_dialog_closed (AdwDialog* _sender,
                                       gpointer self);
VALA_EXTERN void haguichi_window_show_toast (HaguichiWindow* self,
                                 const gchar* title,
                                 guint timeout);
VALA_EXTERN void haguichi_window_show_copied_to_clipboard_toast (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_unselect (HaguichiNetworkList* self);
VALA_EXTERN void haguichi_window_show_sidebar (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_hide_sidebar (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_set_connected_stack_page (HaguichiWindow* self,
                                               const gchar* page);
VALA_EXTERN void haguichi_window_set_disconnected_stack_page (HaguichiWindow* self,
                                                  const gchar* page);
VALA_EXTERN void haguichi_window_set_restore_countdown (HaguichiWindow* self,
                                            gint countdown);
VALA_EXTERN void haguichi_throbber_set_spinning (HaguichiThrobber* self,
                                     gboolean value);
VALA_EXTERN void haguichi_sidebar_show_page (HaguichiSidebar* self,
                                 const gchar* page);
VALA_EXTERN void haguichi_window_set_background_status (HaguichiWindow* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void haguichi_window_set_background_status_finish (HaguichiWindow* self,
                                                   GAsyncResult* _res_);
static void haguichi_window_set_background_status_data_free (gpointer _data);
static gboolean haguichi_window_set_background_status_co (HaguichiWindowSetBackgroundStatusData* _data_);
static void haguichi_window_set_background_status_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN void haguichi_indicator_update_status (HaguichiIndicator* self,
                                       const gchar* mode,
                                       gboolean modal,
                                       gboolean visible);
static void haguichi_window_real_hide (GtkWidget* base);
static gboolean haguichi_window_real_close_request (GtkWindow* base);
VALA_EXTERN void haguichi_window_request_background (HaguichiWindow* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN gboolean haguichi_window_request_background_finish (HaguichiWindow* self,
                                                    GAsyncResult* _res_);
static void ___lambda137_ (HaguichiWindow* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda137__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void haguichi_window_request_background_data_free (gpointer _data);
static gboolean haguichi_window_request_background_co (HaguichiWindowRequestBackgroundData* _data_);
static void haguichi_window_request_background_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void _vala_XdpParent_free (XdpParent* self);
static GObject * haguichi_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void haguichi_window_finalize (GObject * obj);
static GType haguichi_window_get_type_once (void);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
haguichi_window_get_instance_private (HaguichiWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HaguichiWindow_private_offset);
}

static void
__lambda106_ (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 122 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 122 "../src/window.vala"
	haguichi_network_list_refilter (_tmp0_);
#line 498 "window.c"
}

static void
___lambda106__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                               gpointer self)
{
#line 121 "../src/window.vala"
	__lambda106_ ((HaguichiWindow*) self);
#line 507 "window.c"
}

static void
__lambda107_ (HaguichiWindow* self)
{
	HaguichiSession* _tmp0_;
#line 126 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 126 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "visibility-changed", FALSE);
#line 127 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 520 "window.c"
}

static void
___lambda107__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
#line 125 "../src/window.vala"
	__lambda107_ ((HaguichiWindow*) self);
#line 529 "window.c"
}

static void
__lambda108_ (HaguichiWindow* self)
{
	HaguichiSession* _tmp0_;
#line 130 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 130 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "visibility-changed", TRUE);
#line 131 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 542 "window.c"
}

static void
___lambda108__gtk_widget_show (GtkWidget* _sender,
                               gpointer self)
{
#line 129 "../src/window.vala"
	__lambda108_ ((HaguichiWindow*) self);
#line 551 "window.c"
}

HaguichiWindow*
haguichi_window_construct (GType object_type,
                           HaguichiApplication* app)
{
	HaguichiWindow * self = NULL;
	GSettings* config = NULL;
	GSettings* _tmp0_;
	GSettings* list = NULL;
	GSettings* _tmp1_;
	GSettings* ui = NULL;
	GSettings* _tmp2_;
	gchar* _tmp3_ = NULL;
	GAction* sort_by = NULL;
	GSettings* _tmp9_;
	GAction* _tmp10_;
	GAction* _tmp11_;
	GAction* show_offline_members = NULL;
	GSettings* _tmp12_;
	GAction* _tmp13_;
	GAction* _tmp14_;
	GSettings* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	HaguichiIndicator* _tmp22_;
	HaguichiIndicator* _tmp23_;
	GSettings* _tmp24_;
	GtkSearchEntry* _tmp25_;
#line 74 "../src/window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 75 "../src/window.vala"
	self = (HaguichiWindow*) g_object_new (object_type, "application", app, "title", CONFIG_APP_NAME, "icon-name", CONFIG_APP_ID, NULL);
#line 77 "../src/window.vala"
	_tmp0_ = g_settings_new (CONFIG_APP_ID ".config");
#line 77 "../src/window.vala"
	config = _tmp0_;
#line 78 "../src/window.vala"
	_tmp1_ = g_settings_new (CONFIG_APP_ID ".network-list");
#line 78 "../src/window.vala"
	list = _tmp1_;
#line 79 "../src/window.vala"
	_tmp2_ = g_settings_new (CONFIG_APP_ID ".ui");
#line 79 "../src/window.vala"
	ui = _tmp2_;
#line 81 "../src/window.vala"
	if (haguichi_demo_mode) {
#line 603 "window.c"
		gchar* _tmp4_;
#line 81 "../src/window.vala"
		_tmp4_ = g_strdup ("Joe Demo");
#line 81 "../src/window.vala"
		_g_free0 (_tmp3_);
#line 81 "../src/window.vala"
		_tmp3_ = _tmp4_;
#line 611 "window.c"
	} else {
		GSettings* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 81 "../src/window.vala"
		_tmp5_ = config;
#line 81 "../src/window.vala"
		_tmp6_ = g_settings_get_string (_tmp5_, "nickname");
#line 81 "../src/window.vala"
		_tmp7_ = _tmp6_;
#line 81 "../src/window.vala"
		_tmp8_ = haguichi_utils_parse_nick (_tmp7_);
#line 81 "../src/window.vala"
		_g_free0 (_tmp3_);
#line 81 "../src/window.vala"
		_tmp3_ = _tmp8_;
#line 81 "../src/window.vala"
		_g_free0 (_tmp7_);
#line 631 "window.c"
	}
#line 81 "../src/window.vala"
	haguichi_window_set_nick (self, _tmp3_);
#line 83 "../src/window.vala"
	_tmp9_ = list;
#line 83 "../src/window.vala"
	_tmp10_ = g_settings_create_action (_tmp9_, "sort-by");
#line 83 "../src/window.vala"
	sort_by = _tmp10_;
#line 84 "../src/window.vala"
	_tmp11_ = sort_by;
#line 84 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp11_);
#line 86 "../src/window.vala"
	_tmp12_ = list;
#line 86 "../src/window.vala"
	_tmp13_ = g_settings_create_action (_tmp12_, "show-offline-members");
#line 86 "../src/window.vala"
	show_offline_members = _tmp13_;
#line 87 "../src/window.vala"
	_tmp14_ = show_offline_members;
#line 87 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp14_);
#line 89 "../src/window.vala"
	_tmp15_ = ui;
#line 89 "../src/window.vala"
	haguichi_application_set_color_scheme (app, (gint) g_settings_get_enum (_tmp15_, "color-scheme"));
#line 91 "../src/window.vala"
	_tmp17_ = _tmp16_ = g_get_language_names ();
#line 91 "../src/window.vala"
	if (g_strv_contains (_tmp17_, "ru")) {
#line 92 "../src/window.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "custom");
#line 665 "window.c"
	}
#line 111 "../src/window.vala"
	_tmp18_ = ui;
#line 111 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "default-width", g_settings_get_int (_tmp18_, "width"), NULL);
#line 112 "../src/window.vala"
	_tmp19_ = ui;
#line 112 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "default-height", g_settings_get_int (_tmp19_, "height"), NULL);
#line 114 "../src/window.vala"
	_tmp20_ = ui;
#line 114 "../src/window.vala"
	g_settings_bind (_tmp20_, "width", (GObject*) self, "default-width", G_SETTINGS_BIND_DEFAULT);
#line 115 "../src/window.vala"
	_tmp21_ = ui;
#line 115 "../src/window.vala"
	g_settings_bind (_tmp21_, "height", (GObject*) self, "default-height", G_SETTINGS_BIND_DEFAULT);
#line 117 "../src/window.vala"
	_tmp22_ = haguichi_indicator_new ();
#line 117 "../src/window.vala"
	_haguichi_indicator_unref0 (haguichi_indicator);
#line 117 "../src/window.vala"
	haguichi_indicator = _tmp22_;
#line 118 "../src/window.vala"
	_tmp23_ = haguichi_indicator;
#line 118 "../src/window.vala"
	_tmp24_ = ui;
#line 118 "../src/window.vala"
	haguichi_indicator_set_active (_tmp23_, g_settings_get_boolean (_tmp24_, "show-indicator"));
#line 119 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 121 "../src/window.vala"
	_tmp25_ = self->search_entry;
#line 121 "../src/window.vala"
	g_signal_connect_object (_tmp25_, "search-changed", (GCallback) ___lambda106__gtk_search_entry_search_changed, self, 0);
#line 125 "../src/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "hide", (GCallback) ___lambda107__gtk_widget_hide, self, 0);
#line 129 "../src/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) ___lambda108__gtk_widget_show, self, 0);
#line 74 "../src/window.vala"
	_g_object_unref0 (show_offline_members);
#line 74 "../src/window.vala"
	_g_object_unref0 (sort_by);
#line 74 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 74 "../src/window.vala"
	_g_object_unref0 (ui);
#line 74 "../src/window.vala"
	_g_object_unref0 (list);
#line 74 "../src/window.vala"
	_g_object_unref0 (config);
#line 74 "../src/window.vala"
	return self;
#line 719 "window.c"
}

HaguichiWindow*
haguichi_window_new (HaguichiApplication* app)
{
#line 74 "../src/window.vala"
	return haguichi_window_construct (HAGUICHI_TYPE_WINDOW, app);
#line 727 "window.c"
}

static void
haguichi_window_download_hamachi (HaguichiWindow* self)
{
#line 167 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/window.vala"
	haguichi_command_open_redirect_uri ("get-hamachi");
#line 737 "window.c"
}

static void
_haguichi_window_download_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_download_hamachi ((HaguichiWindow*) self);
#line 746 "window.c"
}

static void
haguichi_window_configure_hamachi (HaguichiWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
#line 172 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/window.vala"
	_tmp0_ = self->window_title;
#line 173 "../src/window.vala"
	adw_window_title_set_subtitle (_tmp0_, _ ("Configuring"));
#line 174 "../src/window.vala"
	_tmp1_ = self->priv->configure_button;
#line 174 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 175 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.refresh", FALSE);
#line 176 "../src/window.vala"
	if (!haguichi_demo_mode) {
#line 177 "../src/window.vala"
		haguichi_hamachi_configure ();
#line 770 "window.c"
	}
}

static void
_haguichi_window_configure_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_configure_hamachi ((HaguichiWindow*) self);
#line 780 "window.c"
}

static void
haguichi_window_cancel_restore (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 182 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/window.vala"
	haguichi_controller_restore = FALSE;
#line 184 "../src/window.vala"
	haguichi_controller_connection_stopped ();
#line 185 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 185 "../src/window.vala"
	haguichi_network_list_clear_state (_tmp0_);
#line 797 "window.c"
}

static void
_haguichi_window_cancel_restore_gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_cancel_restore ((HaguichiWindow*) self);
#line 806 "window.c"
}

static void
haguichi_window_go_back_button_clicked (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
#line 189 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 190 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, FALSE);
#line 819 "window.c"
}

static void
_haguichi_window_go_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_go_back_button_clicked ((HaguichiWindow*) self);
#line 828 "window.c"
}

static void
haguichi_window_connect_action (HaguichiWindow* self)
{
#line 193 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/window.vala"
	haguichi_controller_start_hamachi ();
#line 838 "window.c"
}

static void
haguichi_window_disconnect_action (HaguichiWindow* self)
{
#line 197 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/window.vala"
	haguichi_controller_stop_hamachi ();
#line 848 "window.c"
}

static void
haguichi_window_join_network_action (HaguichiWindow* self)
{
#line 201 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/window.vala"
	haguichi_window_add_network_action (self, "Join");
#line 858 "window.c"
}

static void
haguichi_window_create_network_action (HaguichiWindow* self)
{
#line 205 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/window.vala"
	haguichi_window_add_network_action (self, "Create");
#line 868 "window.c"
}

static void
haguichi_window_add_network_action (HaguichiWindow* self,
                                    const gchar* mode)
{
	HaguichiJoinCreateNetworkDialog* add_network = NULL;
	HaguichiJoinCreateNetworkDialog* _tmp0_;
#line 209 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/window.vala"
	g_return_if_fail (mode != NULL);
#line 210 "../src/window.vala"
	_tmp0_ = haguichi_join_create_network_dialog_new (mode);
#line 210 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 210 "../src/window.vala"
	add_network = _tmp0_;
#line 211 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) add_network);
#line 209 "../src/window.vala"
	_g_object_unref0 (add_network);
#line 891 "window.c"
}

static void
haguichi_window_attach_action (HaguichiWindow* self)
{
	HaguichiAttachDialog* attach = NULL;
	HaguichiAttachDialog* _tmp0_;
#line 214 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/window.vala"
	_tmp0_ = haguichi_attach_dialog_new ();
#line 215 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 215 "../src/window.vala"
	attach = _tmp0_;
#line 216 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) attach);
#line 214 "../src/window.vala"
	_g_object_unref0 (attach);
#line 911 "window.c"
}

static void*
__lambda119_ (HaguichiWindow* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	void* result;
#line 221 "../src/window.vala"
	_tmp0_ = haguichi_hamachi_cancel ();
#line 221 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 221 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 222 "../src/window.vala"
	result = NULL;
#line 222 "../src/window.vala"
	return result;
#line 930 "window.c"
}

static gpointer
___lambda119__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda119_ ((HaguichiWindow*) self);
#line 220 "../src/window.vala"
	g_object_unref (self);
#line 220 "../src/window.vala"
	return result;
#line 942 "window.c"
}

static void
haguichi_window_attach_cancel_action (HaguichiWindow* self)
{
	GThread* _tmp0_;
	GThread* _tmp1_;
	HaguichiSidebar* _tmp2_;
#line 219 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/window.vala"
	_tmp0_ = g_thread_new (NULL, ___lambda119__gthread_func, g_object_ref (self));
#line 220 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 220 "../src/window.vala"
	_g_thread_unref0 (_tmp1_);
#line 225 "../src/window.vala"
	_tmp2_ = self->sidebar;
#line 225 "../src/window.vala"
	haguichi_sidebar_set_account (_tmp2_, "-");
#line 963 "window.c"
}

static void
haguichi_window_start_search_action (HaguichiWindow* self)
{
	GtkSearchBar* _tmp0_;
#line 228 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/window.vala"
	_tmp0_ = self->search_bar;
#line 229 "../src/window.vala"
	g_object_set (_tmp0_, "search-mode-enabled", TRUE, NULL);
#line 976 "window.c"
}

static void
haguichi_window_refresh_action (HaguichiWindow* self)
{
#line 232 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/window.vala"
	if (haguichi_controller_last_status <= 1) {
#line 234 "../src/window.vala"
		haguichi_controller_init ();
#line 988 "window.c"
	} else {
#line 235 "../src/window.vala"
		if (haguichi_controller_last_status >= 6) {
#line 236 "../src/window.vala"
			haguichi_controller_update_connection ();
#line 994 "window.c"
		}
	}
}

static void
haguichi_window_toggle_sidebar_action (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 240 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 241 "../src/window.vala"
	_tmp1_ = adw_overlay_split_view_get_collapsed (_tmp0_);
#line 241 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/window.vala"
	if (_tmp2_ == FALSE) {
#line 241 "../src/window.vala"
		return;
#line 1017 "window.c"
	}
#line 243 "../src/window.vala"
	haguichi_window_toggle_sidebar (self);
#line 1021 "window.c"
}

static void
haguichi_window_cycle_mode_action (HaguichiWindow* self)
{
	gchar* cur_mode = NULL;
	gchar* _tmp0_;
	gchar* new_mode = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 251 "../src/window.vala"
	static GQuark _tmp4_label0 = 0;
#line 251 "../src/window.vala"
	static GQuark _tmp4_label1 = 0;
#line 251 "../src/window.vala"
	static GQuark _tmp4_label2 = 0;
#line 251 "../src/window.vala"
	static GQuark _tmp4_label3 = 0;
#line 251 "../src/window.vala"
	static GQuark _tmp4_label4 = 0;
#line 251 "../src/window.vala"
	static GQuark _tmp4_label5 = 0;
#line 1046 "window.c"
	const gchar* _tmp12_;
	const gchar* _tmp13_;
#line 246 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/window.vala"
	if (!haguichi_demo_mode) {
#line 247 "../src/window.vala"
		return;
#line 1055 "window.c"
	}
#line 249 "../src/window.vala"
	_tmp0_ = haguichi_window_get_mode (self);
#line 249 "../src/window.vala"
	cur_mode = _tmp0_;
#line 250 "../src/window.vala"
	_tmp1_ = g_strdup ("");
#line 250 "../src/window.vala"
	new_mode = _tmp1_;
#line 251 "../src/window.vala"
	_tmp2_ = cur_mode;
#line 251 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 251 "../src/window.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 251 "../src/window.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("Initializing")))) {
#line 251 "../src/window.vala"
		switch (0) {
#line 1075 "window.c"
			default:
			{
				gchar* _tmp6_;
#line 253 "../src/window.vala"
				_tmp6_ = g_strdup ("Disconnected");
#line 253 "../src/window.vala"
				_g_free0 (new_mode);
#line 253 "../src/window.vala"
				new_mode = _tmp6_;
#line 254 "../src/window.vala"
				break;
#line 1087 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("Disconnected")))) {
#line 251 "../src/window.vala"
		switch (0) {
#line 1093 "window.c"
			default:
			{
				gchar* _tmp7_;
#line 256 "../src/window.vala"
				_tmp7_ = g_strdup ("Connecting");
#line 256 "../src/window.vala"
				_g_free0 (new_mode);
#line 256 "../src/window.vala"
				new_mode = _tmp7_;
#line 257 "../src/window.vala"
				break;
#line 1105 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("Connecting")))) {
#line 251 "../src/window.vala"
		switch (0) {
#line 1111 "window.c"
			default:
			{
				gchar* _tmp8_;
#line 259 "../src/window.vala"
				_tmp8_ = g_strdup ("Connected");
#line 259 "../src/window.vala"
				_g_free0 (new_mode);
#line 259 "../src/window.vala"
				new_mode = _tmp8_;
#line 260 "../src/window.vala"
				break;
#line 1123 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("Connected")))) {
#line 251 "../src/window.vala"
		switch (0) {
#line 1129 "window.c"
			default:
			{
				gchar* _tmp9_;
#line 262 "../src/window.vala"
				_tmp9_ = g_strdup ("Not installed");
#line 262 "../src/window.vala"
				_g_free0 (new_mode);
#line 262 "../src/window.vala"
				new_mode = _tmp9_;
#line 263 "../src/window.vala"
				break;
#line 1141 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("Not installed")))) {
#line 251 "../src/window.vala"
		switch (0) {
#line 1147 "window.c"
			default:
			{
				gchar* _tmp10_;
#line 265 "../src/window.vala"
				_tmp10_ = g_strdup ("Not configured");
#line 265 "../src/window.vala"
				_g_free0 (new_mode);
#line 265 "../src/window.vala"
				new_mode = _tmp10_;
#line 266 "../src/window.vala"
				break;
#line 1159 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("Not configured")))) {
#line 251 "../src/window.vala"
		switch (0) {
#line 1165 "window.c"
			default:
			{
				gchar* _tmp11_;
#line 268 "../src/window.vala"
				_tmp11_ = g_strdup ("Initializing");
#line 268 "../src/window.vala"
				_g_free0 (new_mode);
#line 268 "../src/window.vala"
				new_mode = _tmp11_;
#line 269 "../src/window.vala"
				break;
#line 1177 "window.c"
			}
		}
	}
#line 272 "../src/window.vala"
	_tmp12_ = new_mode;
#line 272 "../src/window.vala"
	g_debug ("window.vala:272: new mode: %s", _tmp12_);
#line 273 "../src/window.vala"
	_tmp13_ = new_mode;
#line 273 "../src/window.vala"
	haguichi_window_set_mode (self, _tmp13_);
#line 246 "../src/window.vala"
	_g_free0 (new_mode);
#line 246 "../src/window.vala"
	_g_free0 (cur_mode);
#line 1193 "window.c"
}

static void
haguichi_window_expand_all_networks_action (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 276 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 277 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 277 "../src/window.vala"
	haguichi_network_list_set_all_rows_expanded (_tmp0_, TRUE);
#line 1206 "window.c"
}

static void
haguichi_window_collapse_all_networks_action (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 280 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 281 "../src/window.vala"
	haguichi_network_list_set_all_rows_expanded (_tmp0_, FALSE);
#line 1219 "window.c"
}

static void
haguichi_window_preferences_action (HaguichiWindow* self)
{
	HaguichiPreferences* prefs = NULL;
	HaguichiPreferences* _tmp0_ = NULL;
#line 284 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/window.vala"
	_tmp0_ = haguichi_preferences_new ();
#line 285 "../src/window.vala"
	adw_preferences_dialog_set_search_enabled ((AdwPreferencesDialog*) _tmp0_, TRUE);
#line 285 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 285 "../src/window.vala"
	prefs = _tmp0_;
#line 288 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) prefs);
#line 284 "../src/window.vala"
	_g_object_unref0 (prefs);
#line 1241 "window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 293 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 1249 "window.c"
}

static void
haguichi_window_shortcuts_action (HaguichiWindow* self)
{
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GtkShortcutsWindow* shortcuts = NULL;
	GObject* _tmp1_;
	GtkShortcutsWindow* _tmp2_;
#line 291 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/window.vala"
	_tmp0_ = gtk_builder_new_from_resource ("/com/github/ztefn/haguichi/ui/shortcuts.ui");
#line 292 "../src/window.vala"
	builder = _tmp0_;
#line 293 "../src/window.vala"
	_tmp1_ = gtk_builder_get_object (builder, "shortcuts");
#line 293 "../src/window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_shortcuts_window_get_type (), GtkShortcutsWindow));
#line 293 "../src/window.vala"
	shortcuts = _tmp2_;
#line 310 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) shortcuts);
#line 291 "../src/window.vala"
	_g_object_unref0 (shortcuts);
#line 291 "../src/window.vala"
	_g_object_unref0 (builder);
#line 1278 "window.c"
}

static void
haguichi_window_help_action (HaguichiWindow* self)
{
#line 313 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/window.vala"
	haguichi_command_open_redirect_uri ("help");
#line 1288 "window.c"
}

static void
haguichi_window_info_action (HaguichiWindow* self)
{
#line 317 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/window.vala"
	haguichi_window_show_info (self);
#line 1298 "window.c"
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 321 "../src/window.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 321 "../src/window.vala"
	return _data28_;
#line 1308 "window.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 321 "../src/window.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 1318 "window.c"
		HaguichiWindow* self;
#line 321 "../src/window.vala"
		self = _data28_->self;
#line 321 "../src/window.vala"
		_g_object_unref0 (_data28_->about);
#line 321 "../src/window.vala"
		_g_object_unref0 (self);
#line 321 "../src/window.vala"
		g_slice_free (Block28Data, _data28_);
#line 1328 "window.c"
	}
}

static void*
__lambda136_ (Block28Data* _data28_)
{
	HaguichiWindow* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	void* result;
#line 348 "../src/window.vala"
	self = _data28_->self;
#line 349 "../src/window.vala"
	_tmp0_ = haguichi_utils_get_debug_info ();
#line 349 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 349 "../src/window.vala"
	adw_about_dialog_set_debug_info (_data28_->about, _tmp1_);
#line 349 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 350 "../src/window.vala"
	result = NULL;
#line 350 "../src/window.vala"
	return result;
#line 1353 "window.c"
}

static gpointer
___lambda136__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda136_ (self);
#line 348 "../src/window.vala"
	block28_data_unref (self);
#line 348 "../src/window.vala"
	return result;
#line 1365 "window.c"
}

static void
haguichi_window_about_action (HaguichiWindow* self)
{
	Block28Data* _data28_;
	gchar* developer_name = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	AdwAboutDialog* _tmp16_ = NULL;
	AdwAboutDialog* _tmp17_;
	GThread* _tmp18_;
	GThread* _tmp19_;
#line 321 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/window.vala"
	_data28_ = g_slice_new0 (Block28Data);
#line 321 "../src/window.vala"
	_data28_->_ref_count_ = 1;
#line 321 "../src/window.vala"
	_data28_->self = g_object_ref (self);
#line 322 "../src/window.vala"
	_tmp0_ = g_strdup ("Stephen Brandt");
#line 322 "../src/window.vala"
	developer_name = _tmp0_;
#line 323 "../src/window.vala"
	_tmp1_ = g_strdup (CONFIG_APP_NAME);
#line 323 "../src/window.vala"
	_tmp2_ = g_strdup (CONFIG_APP_ID);
#line 323 "../src/window.vala"
	_tmp3_ = g_strconcat ("© 2007-2025 ", developer_name, NULL);
#line 323 "../src/window.vala"
	_tmp4_ = g_date_time_new_now_local ();
#line 323 "../src/window.vala"
	_tmp5_ = _tmp4_;
#line 323 "../src/window.vala"
	_tmp6_ = g_date_time_format (_tmp5_, "%Y-%m-%dT%H:%M");
#line 323 "../src/window.vala"
	_tmp7_ = _tmp6_;
#line 323 "../src/window.vala"
	_tmp8_ = g_strconcat ("haguichi-debug-info_", _tmp7_, NULL);
#line 323 "../src/window.vala"
	_tmp9_ = _tmp8_;
#line 323 "../src/window.vala"
	_tmp10_ = g_strconcat (_tmp9_, ".txt", NULL);
#line 323 "../src/window.vala"
	_tmp11_ = g_strdup (developer_name);
#line 323 "../src/window.vala"
	_tmp12_ = g_strdup ("https://github.com/ztefn/haguichi/issues");
#line 323 "../src/window.vala"
	_tmp13_ = g_strdup (_ ("translator-credits"));
#line 323 "../src/window.vala"
	_tmp14_ = g_strdup (CONFIG_VERSION);
#line 323 "../src/window.vala"
	_tmp15_ = g_strdup ("https://haguichi.net");
#line 323 "../src/window.vala"
	_tmp16_ = (AdwAboutDialog*) adw_about_dialog_new ();
#line 323 "../src/window.vala"
	adw_about_dialog_set_application_name (_tmp16_, _tmp1_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_application_icon (_tmp16_, _tmp2_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp2_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_copyright (_tmp16_, _tmp3_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_debug_info_filename (_tmp16_, _tmp10_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp10_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_developer_name (_tmp16_, _tmp11_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp11_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_issue_url (_tmp16_, _tmp12_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp12_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_license_type (_tmp16_, GTK_LICENSE_GPL_3_0);
#line 323 "../src/window.vala"
	adw_about_dialog_set_translator_credits (_tmp16_, _tmp13_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp13_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_version (_tmp16_, _tmp14_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp14_);
#line 323 "../src/window.vala"
	adw_about_dialog_set_website (_tmp16_, _tmp15_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp15_);
#line 323 "../src/window.vala"
	g_object_set ((GtkWidget*) _tmp16_, "width-request", 320, NULL);
#line 323 "../src/window.vala"
	g_object_ref_sink (_tmp16_);
#line 323 "../src/window.vala"
	_tmp17_ = _tmp16_;
#line 323 "../src/window.vala"
	_g_free0 (_tmp9_);
#line 323 "../src/window.vala"
	_g_free0 (_tmp7_);
#line 323 "../src/window.vala"
	_g_date_time_unref0 (_tmp5_);
#line 323 "../src/window.vala"
	_data28_->about = _tmp17_;
#line 345 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWidget*) _data28_->about);
#line 348 "../src/window.vala"
	_tmp18_ = g_thread_new (NULL, ___lambda136__gthread_func, block28_data_ref (_data28_));
#line 348 "../src/window.vala"
	_tmp19_ = _tmp18_;
#line 348 "../src/window.vala"
	_g_thread_unref0 (_tmp19_);
#line 321 "../src/window.vala"
	_g_free0 (developer_name);
#line 321 "../src/window.vala"
	block28_data_unref (_data28_);
#line 321 "../src/window.vala"
	_data28_ = NULL;
#line 1503 "window.c"
}

static void
haguichi_window_quit_action (HaguichiWindow* self)
{
	GtkWidget* _tmp0_;
	HaguichiConnection* _tmp2_;
	HaguichiSession* _tmp3_;
	HaguichiApplication* _tmp4_;
#line 354 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/window.vala"
	haguichi_controller_quit ();
#line 357 "../src/window.vala"
	_tmp0_ = self->modal_dialog;
#line 357 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 1521 "window.c"
		GtkWidget* _tmp1_;
#line 358 "../src/window.vala"
		_tmp1_ = self->modal_dialog;
#line 358 "../src/window.vala"
		g_signal_emit_by_name (_tmp1_, "destroy");
#line 1527 "window.c"
	}
#line 361 "../src/window.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 363 "../src/window.vala"
	_tmp2_ = haguichi_connection;
#line 363 "../src/window.vala"
	haguichi_connection_save_long_nicks (_tmp2_);
#line 364 "../src/window.vala"
	_tmp3_ = haguichi_session;
#line 364 "../src/window.vala"
	g_signal_emit_by_name (_tmp3_, "quitted");
#line 366 "../src/window.vala"
	g_debug ("window.vala:366: quit_action: Bye!");
#line 367 "../src/window.vala"
	_tmp4_ = haguichi_app;
#line 367 "../src/window.vala"
	g_application_quit ((GApplication*) _tmp4_);
#line 1545 "window.c"
}

void
haguichi_window_trigger_action (HaguichiWindow* self,
                                const gchar* action_name)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 370 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/window.vala"
	g_return_if_fail (action_name != NULL);
#line 371 "../src/window.vala"
	_tmp0_ = g_strconcat ("win.", action_name, NULL);
#line 371 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 371 "../src/window.vala"
	gtk_widget_activate_action_variant ((GtkWidget*) self, _tmp1_, NULL);
#line 371 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 1566 "window.c"
}

static gboolean
___lambda90_ (HaguichiWindow* self)
{
	gboolean result;
#line 382 "../src/window.vala"
	haguichi_window_set_modal_dialog (self, NULL);
#line 383 "../src/window.vala"
	result = FALSE;
#line 383 "../src/window.vala"
	return result;
#line 1579 "window.c"
}

static gboolean
____lambda90__gtk_window_close_request (GtkWindow* _sender,
                                        gpointer self)
{
	gboolean result;
	result = ___lambda90_ ((HaguichiWindow*) self);
#line 381 "../src/window.vala"
	return result;
#line 1590 "window.c"
}

static void
____lambda91_ (HaguichiWindow* self)
{
#line 392 "../src/window.vala"
	haguichi_window_set_modal_dialog (self, NULL);
#line 1598 "window.c"
}

static void
_____lambda91__adw_dialog_closed (AdwDialog* _sender,
                                  gpointer self)
{
#line 391 "../src/window.vala"
	____lambda91_ ((HaguichiWindow*) self);
#line 1607 "window.c"
}

void
haguichi_window_show_dialog (HaguichiWindow* self,
                             GtkWidget* widget)
{
	GtkWidget* _tmp0_;
#line 374 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 374 "../src/window.vala"
	g_return_if_fail (widget != NULL);
#line 375 "../src/window.vala"
	_tmp0_ = self->modal_dialog;
#line 375 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 375 "../src/window.vala"
		return;
#line 1625 "window.c"
	}
#line 377 "../src/window.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_window_get_type ())) {
#line 1629 "window.c"
		GtkWindow* dialog = NULL;
		GtkWindow* _tmp1_;
		GtkWindow* _tmp2_;
		GtkWindow* _tmp3_;
		GtkWindow* _tmp4_;
		GtkWindow* _tmp5_;
		GtkWindow* _tmp6_;
#line 378 "../src/window.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_window_get_type (), GtkWindow));
#line 378 "../src/window.vala"
		dialog = _tmp1_;
#line 379 "../src/window.vala"
		_tmp2_ = dialog;
#line 379 "../src/window.vala"
		gtk_window_set_transient_for (_tmp2_, (GtkWindow*) self);
#line 380 "../src/window.vala"
		_tmp3_ = dialog;
#line 380 "../src/window.vala"
		gtk_window_set_modal (_tmp3_, TRUE);
#line 381 "../src/window.vala"
		_tmp4_ = dialog;
#line 381 "../src/window.vala"
		g_signal_connect_object (_tmp4_, "close-request", (GCallback) ____lambda90__gtk_window_close_request, self, 0);
#line 385 "../src/window.vala"
		_tmp5_ = dialog;
#line 385 "../src/window.vala"
		gtk_window_present (_tmp5_);
#line 387 "../src/window.vala"
		_tmp6_ = dialog;
#line 387 "../src/window.vala"
		haguichi_window_set_modal_dialog (self, (GtkWidget*) _tmp6_);
#line 377 "../src/window.vala"
		_g_object_unref0 (dialog);
#line 1663 "window.c"
	} else {
#line 389 "../src/window.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (widget, adw_dialog_get_type ())) {
#line 1667 "window.c"
			AdwDialog* dialog = NULL;
			AdwDialog* _tmp7_;
			AdwDialog* _tmp8_;
			AdwDialog* _tmp9_;
			AdwDialog* _tmp10_;
#line 390 "../src/window.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, adw_dialog_get_type (), AdwDialog));
#line 390 "../src/window.vala"
			dialog = _tmp7_;
#line 391 "../src/window.vala"
			_tmp8_ = dialog;
#line 391 "../src/window.vala"
			g_signal_connect_object (_tmp8_, "closed", (GCallback) _____lambda91__adw_dialog_closed, self, 0);
#line 394 "../src/window.vala"
			_tmp9_ = dialog;
#line 394 "../src/window.vala"
			adw_dialog_present (_tmp9_, (GtkWidget*) self);
#line 396 "../src/window.vala"
			_tmp10_ = dialog;
#line 396 "../src/window.vala"
			haguichi_window_set_modal_dialog (self, (GtkWidget*) _tmp10_);
#line 389 "../src/window.vala"
			_g_object_unref0 (dialog);
#line 1691 "window.c"
		}
	}
}

static void
haguichi_window_set_modal_dialog (HaguichiWindow* self,
                                  GtkWidget* dialog)
{
	GtkWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
	HaguichiSession* _tmp2_;
#line 400 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 401 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (dialog);
#line 401 "../src/window.vala"
	_g_object_unref0 (self->modal_dialog);
#line 401 "../src/window.vala"
	self->modal_dialog = _tmp0_;
#line 402 "../src/window.vala"
	if (dialog == NULL) {
#line 402 "../src/window.vala"
		_tmp1_ = FALSE;
#line 1715 "window.c"
	} else {
#line 402 "../src/window.vala"
		_tmp1_ = TRUE;
#line 1719 "window.c"
	}
#line 402 "../src/window.vala"
	_tmp2_ = haguichi_session;
#line 402 "../src/window.vala"
	g_signal_emit_by_name (_tmp2_, "modality-changed", _tmp1_);
#line 403 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 1727 "window.c"
}

void
haguichi_window_show_toast (HaguichiWindow* self,
                            const gchar* title,
                            guint timeout)
{
	AdwToastOverlay* _tmp0_;
	AdwToast* _tmp1_ = NULL;
#line 406 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/window.vala"
	g_return_if_fail (title != NULL);
#line 407 "../src/window.vala"
	_tmp0_ = self->priv->toast_overlay;
#line 407 "../src/window.vala"
	_tmp1_ = adw_toast_new (title);
#line 407 "../src/window.vala"
	adw_toast_set_timeout (_tmp1_, timeout);
#line 407 "../src/window.vala"
	adw_toast_overlay_add_toast (_tmp0_, _tmp1_);
#line 1749 "window.c"
}

void
haguichi_window_show_copied_to_clipboard_toast (HaguichiWindow* self)
{
#line 412 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/window.vala"
	haguichi_window_show_toast (self, _ ("Copied to clipboard"), (guint) 2);
#line 1759 "window.c"
}

void
haguichi_window_show_info (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
#line 416 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 417 "../src/window.vala"
	haguichi_network_list_unselect (_tmp0_);
#line 418 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 418 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp1_, TRUE);
#line 1777 "window.c"
}

void
haguichi_window_toggle_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 421 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 422 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 422 "../src/window.vala"
	_tmp2_ = adw_overlay_split_view_get_show_sidebar (_tmp1_);
#line 422 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 422 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, !_tmp3_);
#line 1799 "window.c"
}

void
haguichi_window_show_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	AdwOverlaySplitView* _tmp3_;
#line 425 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 426 "../src/window.vala"
	g_object_get ((GtkWindow*) self, "default-width", &_tmp1_, NULL);
#line 426 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 426 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, _tmp2_ > 520);
#line 427 "../src/window.vala"
	_tmp3_ = self->split_view;
#line 427 "../src/window.vala"
	adw_overlay_split_view_set_pin_sidebar (_tmp3_, FALSE);
#line 1823 "window.c"
}

void
haguichi_window_hide_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
#line 430 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 431 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 431 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, FALSE);
#line 432 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 432 "../src/window.vala"
	adw_overlay_split_view_set_pin_sidebar (_tmp1_, TRUE);
#line 1841 "window.c"
}

void
haguichi_window_set_nick (HaguichiWindow* self,
                          const gchar* nick)
{
	const gchar* _tmp0_ = NULL;
	AdwWindowTitle* _tmp1_;
#line 435 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/window.vala"
	g_return_if_fail (nick != NULL);
#line 436 "../src/window.vala"
	if (g_strcmp0 (nick, "") == 0) {
#line 436 "../src/window.vala"
		_tmp0_ = _ ("Anonymous");
#line 1858 "window.c"
	} else {
#line 436 "../src/window.vala"
		_tmp0_ = nick;
#line 1862 "window.c"
	}
#line 436 "../src/window.vala"
	_tmp1_ = self->window_title;
#line 436 "../src/window.vala"
	adw_window_title_set_title (_tmp1_, _tmp0_);
#line 1868 "window.c"
}

void
haguichi_window_set_connected_stack_page (HaguichiWindow* self,
                                          const gchar* page)
{
	GtkStack* _tmp0_;
#line 439 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 439 "../src/window.vala"
	g_return_if_fail (page != NULL);
#line 440 "../src/window.vala"
	_tmp0_ = self->connected_stack;
#line 440 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, page);
#line 1884 "window.c"
}

void
haguichi_window_set_disconnected_stack_page (HaguichiWindow* self,
                                             const gchar* page)
{
	GtkStack* _tmp0_;
#line 443 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 443 "../src/window.vala"
	g_return_if_fail (page != NULL);
#line 444 "../src/window.vala"
	_tmp0_ = self->disconnected_stack;
#line 444 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, page);
#line 1900 "window.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1922 "window.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1926 "window.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1932 "window.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1936 "window.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1940 "window.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1948 "window.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1976 "window.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1985 "window.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1999 "window.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 2008 "window.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 2022 "window.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2031 "window.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 2040 "window.c"
}

void
haguichi_window_set_restore_countdown (HaguichiWindow* self,
                                       gint countdown)
{
	AdwStatusPage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 447 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 448 "../src/window.vala"
	_tmp0_ = self->restore_status_page;
#line 448 "../src/window.vala"
	_tmp1_ = g_strdup_printf ("%i", countdown);
#line 448 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 448 "../src/window.vala"
	_tmp3_ = string_replace (ngettext ("Reconnecting in {0} second", "Reconnecting in {0} seconds", (gulong) countdown), "{0}", _tmp2_);
#line 448 "../src/window.vala"
	_tmp4_ = _tmp3_;
#line 448 "../src/window.vala"
	adw_status_page_set_description (_tmp0_, _tmp4_);
#line 448 "../src/window.vala"
	_g_free0 (_tmp4_);
#line 448 "../src/window.vala"
	_g_free0 (_tmp2_);
#line 2070 "window.c"
}

gchar*
haguichi_window_get_mode (HaguichiWindow* self)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 453 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 454 "../src/window.vala"
	_tmp0_ = self->stack;
#line 454 "../src/window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 454 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 454 "../src/window.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 454 "../src/window.vala"
	result = _tmp3_;
#line 454 "../src/window.vala"
	return result;
#line 2095 "window.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 2114 "window.c"
}

void
haguichi_window_set_mode (HaguichiWindow* self,
                          const gchar* mode)
{
	HaguichiSession* _tmp0_;
	GtkStack* _tmp1_;
	gboolean is_configured = FALSE;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkButton* _tmp6_;
	GtkToggleButton* _tmp14_;
	gboolean _tmp15_ = FALSE;
	GtkToggleButton* _tmp16_;
	GtkToggleButton* _tmp17_;
	GtkToggleButton* _tmp18_;
	GtkSearchBar* _tmp19_;
	HaguichiThrobber* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkMenuButton* _tmp28_;
#line 457 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 457 "../src/window.vala"
	g_return_if_fail (mode != NULL);
#line 458 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 458 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "mode-changed", mode);
#line 460 "../src/window.vala"
	_tmp1_ = self->stack;
#line 460 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp1_, mode);
#line 462 "../src/window.vala"
	_tmp2_ = g_utf8_strdown (mode, (gssize) -1);
#line 462 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 462 "../src/window.vala"
	_tmp4_ = string_contains (_tmp3_, "connect");
#line 462 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 462 "../src/window.vala"
	is_configured = _tmp4_;
#line 464 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.connect", g_strcmp0 (mode, "Disconnected") == 0);
#line 465 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.disconnect", g_strcmp0 (mode, "Connected") == 0);
#line 466 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.join-network", g_strcmp0 (mode, "Connected") == 0);
#line 467 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.create-network", g_strcmp0 (mode, "Connected") == 0);
#line 468 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.start-search", g_strcmp0 (mode, "Connected") == 0);
#line 469 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.refresh", TRUE);
#line 470 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.toggle-sidebar", is_configured);
#line 471 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.info", is_configured);
#line 472 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.sort-by", is_configured);
#line 473 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.show-offline-members", is_configured);
#line 475 "../src/window.vala"
	if (g_strcmp0 (mode, "Not installed") == 0) {
#line 475 "../src/window.vala"
		_tmp5_ = TRUE;
#line 2185 "window.c"
	} else {
#line 475 "../src/window.vala"
		_tmp5_ = g_strcmp0 (mode, "Not configured") == 0;
#line 2189 "window.c"
	}
#line 475 "../src/window.vala"
	_tmp6_ = self->priv->refresh_button;
#line 475 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp5_);
#line 477 "../src/window.vala"
	if (g_strcmp0 (mode, "Not installed") == 0) {
#line 2197 "window.c"
		gboolean _tmp7_ = FALSE;
#line 478 "../src/window.vala"
		if (haguichi_demo_mode) {
#line 478 "../src/window.vala"
			_tmp7_ = TRUE;
#line 2203 "window.c"
		} else {
			const gchar* _tmp8_;
#line 478 "../src/window.vala"
			_tmp8_ = haguichi_hamachi_version;
#line 478 "../src/window.vala"
			_tmp7_ = g_strcmp0 (_tmp8_, "") == 0;
#line 2210 "window.c"
		}
#line 478 "../src/window.vala"
		if (_tmp7_) {
#line 2214 "window.c"
			AdwStatusPage* _tmp9_;
#line 479 "../src/window.vala"
			_tmp9_ = self->not_installed_status_page;
#line 479 "../src/window.vala"
			adw_status_page_set_title (_tmp9_, _ ("Hamachi Is Not Installed"));
#line 2220 "window.c"
		} else {
			AdwStatusPage* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 481 "../src/window.vala"
			_tmp10_ = self->not_installed_status_page;
#line 481 "../src/window.vala"
			_tmp11_ = haguichi_hamachi_version;
#line 481 "../src/window.vala"
			_tmp12_ = g_strdup_printf (_ ("Hamachi Version %s Is Obsolete"), _tmp11_);
#line 481 "../src/window.vala"
			_tmp13_ = _tmp12_;
#line 481 "../src/window.vala"
			adw_status_page_set_title (_tmp10_, _tmp13_);
#line 481 "../src/window.vala"
			_g_free0 (_tmp13_);
#line 2238 "window.c"
		}
	}
#line 485 "../src/window.vala"
	_tmp14_ = self->connect_button;
#line 485 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp14_, g_strcmp0 (mode, "Disconnected") == 0);
#line 486 "../src/window.vala"
	if (g_strcmp0 (mode, "Connecting") == 0) {
#line 486 "../src/window.vala"
		_tmp15_ = TRUE;
#line 2249 "window.c"
	} else {
#line 486 "../src/window.vala"
		_tmp15_ = g_strcmp0 (mode, "Connected") == 0;
#line 2253 "window.c"
	}
#line 486 "../src/window.vala"
	_tmp16_ = self->disconnect_button;
#line 486 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp16_, _tmp15_);
#line 488 "../src/window.vala"
	_tmp17_ = self->search_button;
#line 488 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp17_, is_configured);
#line 489 "../src/window.vala"
	_tmp18_ = self->search_button;
#line 489 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, g_strcmp0 (mode, "Connected") == 0);
#line 490 "../src/window.vala"
	_tmp19_ = self->search_bar;
#line 490 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, g_strcmp0 (mode, "Connected") == 0);
#line 491 "../src/window.vala"
	if (g_strcmp0 (mode, "Connected") != 0) {
#line 2273 "window.c"
		GtkSearchBar* _tmp20_;
#line 492 "../src/window.vala"
		_tmp20_ = self->search_bar;
#line 492 "../src/window.vala"
		g_object_set (_tmp20_, "search-mode-enabled", FALSE, NULL);
#line 2279 "window.c"
	}
#line 495 "../src/window.vala"
	if (is_configured) {
#line 2283 "window.c"
		HaguichiSidebar* _tmp21_;
		GtkButton* _tmp22_;
		HaguichiSidebar* _tmp23_;
		GtkButton* _tmp24_;
#line 496 "../src/window.vala"
		_tmp21_ = self->sidebar;
#line 496 "../src/window.vala"
		_tmp22_ = _tmp21_->attach_button;
#line 496 "../src/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, g_strcmp0 (mode, "Connected") == 0);
#line 497 "../src/window.vala"
		_tmp23_ = self->sidebar;
#line 497 "../src/window.vala"
		_tmp24_ = _tmp23_->cancel_button;
#line 497 "../src/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, g_strcmp0 (mode, "Connected") == 0);
#line 498 "../src/window.vala"
		haguichi_window_show_sidebar (self);
#line 2302 "window.c"
	} else {
#line 500 "../src/window.vala"
		haguichi_window_hide_sidebar (self);
#line 2306 "window.c"
	}
#line 503 "../src/window.vala"
	_tmp25_ = self->throbber;
#line 503 "../src/window.vala"
	haguichi_throbber_set_spinning (_tmp25_, g_strcmp0 (mode, "Connecting") == 0);
#line 505 "../src/window.vala"
	_tmp26_ = self->priv->configure_button;
#line 505 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, g_strcmp0 (mode, "Not configured") == 0);
#line 507 "../src/window.vala"
	_tmp27_ = self->priv->overlay_refresh_button;
#line 507 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp27_, g_strcmp0 (mode, "Connected") == 0);
#line 508 "../src/window.vala"
	_tmp28_ = self->priv->overlay_add_network_button;
#line 508 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp28_, g_strcmp0 (mode, "Connected") == 0);
#line 510 "../src/window.vala"
	if (g_strcmp0 (mode, "Initializing") == 0) {
#line 2326 "window.c"
		AdwWindowTitle* _tmp29_;
#line 511 "../src/window.vala"
		_tmp29_ = self->window_title;
#line 511 "../src/window.vala"
		adw_window_title_set_subtitle (_tmp29_, _ ("Initializing"));
#line 2332 "window.c"
	} else {
#line 512 "../src/window.vala"
		if (g_strcmp0 (mode, "Connecting") == 0) {
#line 2336 "window.c"
			AdwWindowTitle* _tmp30_;
#line 513 "../src/window.vala"
			_tmp30_ = self->window_title;
#line 513 "../src/window.vala"
			adw_window_title_set_subtitle (_tmp30_, _ ("Connecting"));
#line 2342 "window.c"
		} else {
#line 514 "../src/window.vala"
			if (g_strcmp0 (mode, "Connected") == 0) {
#line 2346 "window.c"
				AdwWindowTitle* _tmp31_;
#line 515 "../src/window.vala"
				_tmp31_ = self->window_title;
#line 515 "../src/window.vala"
				adw_window_title_set_subtitle (_tmp31_, _ ("Connected"));
#line 2352 "window.c"
			} else {
				AdwWindowTitle* _tmp32_;
				HaguichiSidebar* _tmp33_;
#line 517 "../src/window.vala"
				_tmp32_ = self->window_title;
#line 517 "../src/window.vala"
				adw_window_title_set_subtitle (_tmp32_, _ ("Disconnected"));
#line 518 "../src/window.vala"
				_tmp33_ = self->sidebar;
#line 518 "../src/window.vala"
				haguichi_sidebar_show_page (_tmp33_, "Information");
#line 2364 "window.c"
			}
		}
	}
#line 522 "../src/window.vala"
	if (xdp_portal_running_under_flatpak ()) {
#line 523 "../src/window.vala"
		haguichi_window_set_background_status (self, NULL, NULL);
#line 2372 "window.c"
	}
#line 526 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 2376 "window.c"
}

static void
haguichi_window_set_background_status_data_free (gpointer _data)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
	_data_ = _data;
#line 17 "../src/window.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/window.vala"
	g_slice_free (HaguichiWindowSetBackgroundStatusData, _data_);
#line 2388 "window.c"
}

void
haguichi_window_set_background_status (HaguichiWindow* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
	HaguichiWindow* _tmp0_;
#line 17 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/window.vala"
	_data_ = g_slice_new0 (HaguichiWindowSetBackgroundStatusData);
#line 17 "../src/window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 17 "../src/window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, haguichi_window_set_background_status_data_free);
#line 17 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/window.vala"
	_data_->self = _tmp0_;
#line 17 "../src/window.vala"
	haguichi_window_set_background_status_co (_data_);
#line 2412 "window.c"
}

void
haguichi_window_set_background_status_finish (HaguichiWindow* self,
                                              GAsyncResult* _res_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
#line 17 "../src/window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2422 "window.c"
}

static void
haguichi_window_set_background_status_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
#line 531 "../src/window.vala"
	_data_ = _user_data_;
#line 531 "../src/window.vala"
	_data_->_source_object_ = source_object;
#line 531 "../src/window.vala"
	_data_->_res_ = _res_;
#line 531 "../src/window.vala"
	haguichi_window_set_background_status_co (_data_);
#line 2439 "window.c"
}

static gboolean
haguichi_window_set_background_status_co (HaguichiWindowSetBackgroundStatusData* _data_)
{
#line 529 "../src/window.vala"
	switch (_data_->_state_) {
#line 529 "../src/window.vala"
		case 0:
#line 2449 "window.c"
		goto _state_0;
#line 529 "../src/window.vala"
		case 1:
#line 2453 "window.c"
		goto _state_1;
		default:
#line 529 "../src/window.vala"
		g_assert_not_reached ();
#line 2458 "window.c"
	}
	_state_0:
	{
#line 531 "../src/window.vala"
		_data_->_tmp0_ = _data_->self->priv->portal;
#line 531 "../src/window.vala"
		_data_->_tmp1_ = _data_->self->window_title;
#line 531 "../src/window.vala"
		_data_->_tmp2_ = adw_window_title_get_subtitle (_data_->_tmp1_);
#line 531 "../src/window.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 531 "../src/window.vala"
		_data_->_state_ = 1;
#line 531 "../src/window.vala"
		xdp_portal_set_background_status (_data_->_tmp0_, _data_->_tmp3_, NULL, haguichi_window_set_background_status_ready, _data_);
#line 531 "../src/window.vala"
		return FALSE;
#line 2476 "window.c"
		_state_1:
#line 531 "../src/window.vala"
		_data_->success = xdp_portal_set_background_status_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 531 "../src/window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2482 "window.c"
			goto __catch0_g_error;
		}
#line 532 "../src/window.vala"
		if (!_data_->success) {
#line 533 "../src/window.vala"
			g_warning ("window.vala:533: set_background_status: Updating background status fai" \
"led");
#line 2489 "window.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 530 "../src/window.vala"
		_data_->e = _data_->_inner_error0_;
#line 530 "../src/window.vala"
		_data_->_inner_error0_ = NULL;
#line 536 "../src/window.vala"
		_data_->_tmp4_ = _data_->e;
#line 536 "../src/window.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 536 "../src/window.vala"
		g_critical ("window.vala:536: set_background_status: %s", _data_->_tmp5_);
#line 530 "../src/window.vala"
		_g_error_free0 (_data_->e);
#line 2507 "window.c"
	}
	__finally0:
#line 530 "../src/window.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 530 "../src/window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 530 "../src/window.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 530 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 530 "../src/window.vala"
		return FALSE;
#line 2520 "window.c"
	}
#line 529 "../src/window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 529 "../src/window.vala"
	if (_data_->_state_ != 0) {
#line 529 "../src/window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 529 "../src/window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2530 "window.c"
		}
	}
#line 529 "../src/window.vala"
	g_object_unref (_data_->_async_result);
#line 529 "../src/window.vala"
	return FALSE;
#line 2537 "window.c"
}

void
haguichi_window_update_indicator_status (HaguichiWindow* self)
{
	HaguichiIndicator* _tmp0_;
#line 540 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/window.vala"
	_tmp0_ = haguichi_indicator;
#line 541 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 2550 "window.c"
		HaguichiIndicator* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GtkWidget* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 542 "../src/window.vala"
		_tmp1_ = haguichi_indicator;
#line 542 "../src/window.vala"
		_tmp2_ = haguichi_window_get_mode (self);
#line 542 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 542 "../src/window.vala"
		_tmp4_ = self->modal_dialog;
#line 542 "../src/window.vala"
		_tmp5_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 542 "../src/window.vala"
		_tmp6_ = _tmp5_;
#line 542 "../src/window.vala"
		haguichi_indicator_update_status (_tmp1_, _tmp3_, _tmp4_ != NULL, _tmp6_);
#line 542 "../src/window.vala"
		_g_free0 (_tmp3_);
#line 2573 "window.c"
	}
}

static void
haguichi_window_real_hide (GtkWidget* base)
{
	HaguichiWindow * self;
	GtkWidget* _tmp0_;
#line 546 "../src/window.vala"
	self = (HaguichiWindow*) base;
#line 547 "../src/window.vala"
	_tmp0_ = self->modal_dialog;
#line 547 "../src/window.vala"
	if (_tmp0_ == NULL) {
#line 548 "../src/window.vala"
		GTK_WIDGET_CLASS (haguichi_window_parent_class)->hide ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow));
#line 2590 "window.c"
	}
}

static void
___lambda137_ (HaguichiWindow* self,
               GObject* obj,
               GAsyncResult* res)
{
#line 556 "../src/window.vala"
	g_return_if_fail (res != NULL);
#line 557 "../src/window.vala"
	if (haguichi_window_request_background_finish (self, res)) {
#line 558 "../src/window.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 2605 "window.c"
	} else {
#line 560 "../src/window.vala"
		gtk_window_destroy ((GtkWindow*) self);
#line 2609 "window.c"
	}
}

static void
____lambda137__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 556 "../src/window.vala"
	___lambda137_ ((HaguichiWindow*) self, source_object, res);
#line 556 "../src/window.vala"
	g_object_unref (self);
#line 2622 "window.c"
}

static gboolean
haguichi_window_real_close_request (GtkWindow* base)
{
	HaguichiWindow * self;
	gchar* mode = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 552 "../src/window.vala"
	self = (HaguichiWindow*) base;
#line 554 "../src/window.vala"
	_tmp0_ = haguichi_window_get_mode (self);
#line 554 "../src/window.vala"
	mode = _tmp0_;
#line 555 "../src/window.vala"
	_tmp2_ = mode;
#line 555 "../src/window.vala"
	if (g_strcmp0 (_tmp2_, "Connecting") == 0) {
#line 555 "../src/window.vala"
		_tmp1_ = TRUE;
#line 2646 "window.c"
	} else {
		const gchar* _tmp3_;
#line 555 "../src/window.vala"
		_tmp3_ = mode;
#line 555 "../src/window.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "Connected") == 0;
#line 2653 "window.c"
	}
#line 555 "../src/window.vala"
	if (_tmp1_) {
#line 556 "../src/window.vala"
		haguichi_window_request_background (self, ____lambda137__gasync_ready_callback, g_object_ref (self));
#line 2659 "window.c"
	} else {
#line 564 "../src/window.vala"
		gtk_window_destroy ((GtkWindow*) self);
#line 2663 "window.c"
	}
#line 567 "../src/window.vala"
	result = TRUE;
#line 567 "../src/window.vala"
	_g_free0 (mode);
#line 567 "../src/window.vala"
	return result;
#line 2671 "window.c"
}

static void
haguichi_window_request_background_data_free (gpointer _data)
{
	HaguichiWindowRequestBackgroundData* _data_;
	_data_ = _data;
#line 17 "../src/window.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/window.vala"
	g_slice_free (HaguichiWindowRequestBackgroundData, _data_);
#line 2683 "window.c"
}

void
haguichi_window_request_background (HaguichiWindow* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	HaguichiWindowRequestBackgroundData* _data_;
	HaguichiWindow* _tmp0_;
#line 17 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/window.vala"
	_data_ = g_slice_new0 (HaguichiWindowRequestBackgroundData);
#line 17 "../src/window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 17 "../src/window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, haguichi_window_request_background_data_free);
#line 17 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/window.vala"
	_data_->self = _tmp0_;
#line 17 "../src/window.vala"
	haguichi_window_request_background_co (_data_);
#line 2707 "window.c"
}

gboolean
haguichi_window_request_background_finish (HaguichiWindow* self,
                                           GAsyncResult* _res_)
{
	gboolean result;
	HaguichiWindowRequestBackgroundData* _data_;
#line 17 "../src/window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 17 "../src/window.vala"
	result = _data_->result;
#line 17 "../src/window.vala"
	return result;
#line 2722 "window.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 578 "../src/window.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 2730 "window.c"
}

static void
haguichi_window_request_background_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	HaguichiWindowRequestBackgroundData* _data_;
#line 578 "../src/window.vala"
	_data_ = _user_data_;
#line 578 "../src/window.vala"
	_data_->_source_object_ = source_object;
#line 578 "../src/window.vala"
	_data_->_res_ = _res_;
#line 578 "../src/window.vala"
	haguichi_window_request_background_co (_data_);
#line 2747 "window.c"
}

static void
_vala_XdpParent_free (XdpParent* self)
{
#line 578 "../src/window.vala"
	g_boxed_free (xdp_parent_get_type (), self);
#line 2755 "window.c"
}

static gboolean
haguichi_window_request_background_co (HaguichiWindowRequestBackgroundData* _data_)
{
#line 570 "../src/window.vala"
	switch (_data_->_state_) {
#line 570 "../src/window.vala"
		case 0:
#line 2765 "window.c"
		goto _state_0;
#line 570 "../src/window.vala"
		case 1:
#line 2769 "window.c"
		goto _state_1;
		default:
#line 570 "../src/window.vala"
		g_assert_not_reached ();
#line 2774 "window.c"
	}
	_state_0:
#line 571 "../src/window.vala"
	_data_->_tmp0_ = xdp_parent_new_gtk ((GtkWindow*) _data_->self);
#line 571 "../src/window.vala"
	_data_->parent = _data_->_tmp0_;
#line 573 "../src/window.vala"
	_data_->_tmp1_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 573 "../src/window.vala"
	_data_->command = _data_->_tmp1_;
#line 574 "../src/window.vala"
	g_ptr_array_add (_data_->command, CONFIG_APP_ID);
#line 575 "../src/window.vala"
	g_ptr_array_add (_data_->command, "--background");
#line 2789 "window.c"
	{
#line 578 "../src/window.vala"
		_data_->_tmp3_ = _data_->self->priv->portal;
#line 578 "../src/window.vala"
		_data_->_tmp4_ = _g_ptr_array_ref0 (_data_->command);
#line 578 "../src/window.vala"
		_data_->_state_ = 1;
#line 578 "../src/window.vala"
		xdp_portal_request_background (_data_->_tmp3_, _data_->parent, _ ("Haguichi will continue to run when its window is closed so that it can" \
" monitor the connection and send notifications."), _data_->_tmp4_, XDP_BACKGROUND_FLAG_NONE, NULL, haguichi_window_request_background_ready, _data_);
#line 578 "../src/window.vala"
		return FALSE;
#line 2801 "window.c"
		_state_1:
#line 578 "../src/window.vala"
		_data_->_tmp2_ = xdp_portal_request_background_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 578 "../src/window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2807 "window.c"
			goto __catch0_g_error;
		}
#line 578 "../src/window.vala"
		_data_->result = _data_->_tmp2_;
#line 578 "../src/window.vala"
		_g_ptr_array_unref0 (_data_->command);
#line 578 "../src/window.vala"
		__vala_XdpParent_free0 (_data_->parent);
#line 578 "../src/window.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 578 "../src/window.vala"
		if (_data_->_state_ != 0) {
#line 578 "../src/window.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 578 "../src/window.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2824 "window.c"
			}
		}
#line 578 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 578 "../src/window.vala"
		return FALSE;
#line 2831 "window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 577 "../src/window.vala"
		_data_->e = _data_->_inner_error0_;
#line 577 "../src/window.vala"
		_data_->_inner_error0_ = NULL;
#line 586 "../src/window.vala"
		_data_->_tmp5_ = _data_->e;
#line 586 "../src/window.vala"
		_data_->_tmp6_ = _data_->_tmp5_->message;
#line 586 "../src/window.vala"
		g_critical ("window.vala:586: request_background: %s", _data_->_tmp6_);
#line 588 "../src/window.vala"
		_data_->result = TRUE;
#line 588 "../src/window.vala"
		_g_error_free0 (_data_->e);
#line 588 "../src/window.vala"
		_g_ptr_array_unref0 (_data_->command);
#line 588 "../src/window.vala"
		__vala_XdpParent_free0 (_data_->parent);
#line 588 "../src/window.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 588 "../src/window.vala"
		if (_data_->_state_ != 0) {
#line 588 "../src/window.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 588 "../src/window.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2862 "window.c"
			}
		}
#line 588 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 588 "../src/window.vala"
		return FALSE;
#line 2869 "window.c"
	}
	__finally0:
#line 577 "../src/window.vala"
	_g_ptr_array_unref0 (_data_->command);
#line 577 "../src/window.vala"
	__vala_XdpParent_free0 (_data_->parent);
#line 577 "../src/window.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 577 "../src/window.vala"
	g_clear_error (&_data_->_inner_error0_);
#line 577 "../src/window.vala"
	g_object_unref (_data_->_async_result);
#line 577 "../src/window.vala"
	return FALSE;
#line 2884 "window.c"
}

static GObject *
haguichi_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HaguichiWindow * self;
#line 135 "../src/window.vala"
	parent_class = G_OBJECT_CLASS (haguichi_window_parent_class);
#line 135 "../src/window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 135 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_WINDOW, HaguichiWindow);
#line 136 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.connect", NULL, (GtkWidgetActionActivateFunc) haguichi_window_connect_action);
#line 137 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.disconnect", NULL, (GtkWidgetActionActivateFunc) haguichi_window_disconnect_action);
#line 138 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.join-network", NULL, (GtkWidgetActionActivateFunc) haguichi_window_join_network_action);
#line 139 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.create-network", NULL, (GtkWidgetActionActivateFunc) haguichi_window_create_network_action);
#line 140 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.attach", NULL, (GtkWidgetActionActivateFunc) haguichi_window_attach_action);
#line 141 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.attach-cancel", NULL, (GtkWidgetActionActivateFunc) haguichi_window_attach_cancel_action);
#line 142 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.start-search", NULL, (GtkWidgetActionActivateFunc) haguichi_window_start_search_action);
#line 143 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.refresh", NULL, (GtkWidgetActionActivateFunc) haguichi_window_refresh_action);
#line 144 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.toggle-sidebar", NULL, (GtkWidgetActionActivateFunc) haguichi_window_toggle_sidebar_action);
#line 145 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.cycle-mode", NULL, (GtkWidgetActionActivateFunc) haguichi_window_cycle_mode_action);
#line 146 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.expand-all-networks", NULL, (GtkWidgetActionActivateFunc) haguichi_window_expand_all_networks_action);
#line 147 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.collapse-all-networks", NULL, (GtkWidgetActionActivateFunc) haguichi_window_collapse_all_networks_action);
#line 148 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.preferences", NULL, (GtkWidgetActionActivateFunc) haguichi_window_preferences_action);
#line 149 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.shortcuts", NULL, (GtkWidgetActionActivateFunc) haguichi_window_shortcuts_action);
#line 150 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.help", NULL, (GtkWidgetActionActivateFunc) haguichi_window_help_action);
#line 151 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.info", NULL, (GtkWidgetActionActivateFunc) haguichi_window_info_action);
#line 152 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.about", NULL, (GtkWidgetActionActivateFunc) haguichi_window_about_action);
#line 153 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.quit", NULL, (GtkWidgetActionActivateFunc) haguichi_window_quit_action);
#line 135 "../src/window.vala"
	return obj;
#line 2939 "window.c"
}

static void
haguichi_window_class_init (HaguichiWindowClass * klass,
                            gpointer klass_data)
{
#line 17 "../src/window.vala"
	haguichi_window_parent_class = g_type_class_peek_parent (klass);
#line 17 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &HaguichiWindow_private_offset);
#line 17 "../src/window.vala"
	((GtkWidgetClass *) klass)->hide = (void (*) (GtkWidget*)) haguichi_window_real_hide;
#line 17 "../src/window.vala"
	((GtkWindowClass *) klass)->close_request = (gboolean (*) (GtkWindow*)) haguichi_window_real_close_request;
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (klass)->constructor = haguichi_window_constructor;
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = haguichi_window_finalize;
#line 17 "../src/window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/ztefn/haguichi/ui/window.ui");
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toast_overlay", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, toast_overlay));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "split_view", FALSE, G_STRUCT_OFFSET (HaguichiWindow, split_view));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "window_title", FALSE, G_STRUCT_OFFSET (HaguichiWindow, window_title));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "not_installed_status_page", FALSE, G_STRUCT_OFFSET (HaguichiWindow, not_installed_status_page));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sidebar", FALSE, G_STRUCT_OFFSET (HaguichiWindow, sidebar));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "network_list", FALSE, G_STRUCT_OFFSET (HaguichiWindow, network_list));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "refresh_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, refresh_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connect_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, connect_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "disconnect_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, disconnect_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_bar", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_bar));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_entry", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_entry));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, G_STRUCT_OFFSET (HaguichiWindow, stack));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connected_stack", FALSE, G_STRUCT_OFFSET (HaguichiWindow, connected_stack));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "disconnected_stack", FALSE, G_STRUCT_OFFSET (HaguichiWindow, disconnected_stack));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "restore_status_page", FALSE, G_STRUCT_OFFSET (HaguichiWindow, restore_status_page));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "throbber", FALSE, G_STRUCT_OFFSET (HaguichiWindow, throbber));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "configure_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, configure_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay_refresh_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, overlay_refresh_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay_add_network_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, overlay_add_network_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "download_hamachi", G_CALLBACK(_haguichi_window_download_hamachi_gtk_button_clicked));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "configure_hamachi", G_CALLBACK(_haguichi_window_configure_hamachi_gtk_button_clicked));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_restore", G_CALLBACK(_haguichi_window_cancel_restore_gtk_button_clicked));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "go_back_button_clicked", G_CALLBACK(_haguichi_window_go_back_button_clicked_gtk_button_clicked));
#line 3008 "window.c"
}

static void
haguichi_window_instance_init (HaguichiWindow * self,
                               gpointer klass)
{
	XdpPortal* _tmp0_;
#line 17 "../src/window.vala"
	self->priv = haguichi_window_get_instance_private (self);
#line 63 "../src/window.vala"
	_tmp0_ = xdp_portal_new ();
#line 63 "../src/window.vala"
	self->priv->portal = _tmp0_;
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_SIDEBAR);
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_NETWORK_LIST);
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_THROBBER);
#line 17 "../src/window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 3030 "window.c"
}

static void
haguichi_window_finalize (GObject * obj)
{
	HaguichiWindow * self;
#line 17 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_WINDOW, HaguichiWindow);
#line 63 "../src/window.vala"
	_g_object_unref0 (self->priv->portal);
#line 65 "../src/window.vala"
	_g_object_unref0 (self->modal_dialog);
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (haguichi_window_parent_class)->finalize (obj);
#line 3045 "window.c"
}

static GType
haguichi_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiWindow), 0, (GInstanceInitFunc) haguichi_window_instance_init, NULL };
	GType haguichi_window_type_id;
	haguichi_window_type_id = g_type_register_static (adw_application_window_get_type (), "HaguichiWindow", &g_define_type_info, 0);
	HaguichiWindow_private_offset = g_type_add_instance_private (haguichi_window_type_id, sizeof (HaguichiWindowPrivate));
	return haguichi_window_type_id;
}

GType
haguichi_window_get_type (void)
{
	static volatile gsize haguichi_window_type_id__once = 0;
	if (g_once_init_enter (&haguichi_window_type_id__once)) {
		GType haguichi_window_type_id;
		haguichi_window_type_id = haguichi_window_get_type_once ();
		g_once_init_leave (&haguichi_window_type_id__once, haguichi_window_type_id);
	}
	return haguichi_window_type_id__once;
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

